c=======================================================================
c***********************************************************************
      subroutine new_frac(ngt)
c***********************************************************************
c======================================================================= 
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/annppf.common'
      include './com_18/burned.common'
      include './com_18/coord.common' 
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/ecoin.common'
      include './com_18/estab.common'
      include './com_18/files_car.common'
      include './com_18/frac_change.common'
      include './com_18/gddpix.common'
      include './com_18/inidata.common'
      include './com_18/init.common'
      include './com_18/input_par.common'
      include './com_18/landuse.common'      
      include './com_18/mort.common'
      include './com_18/npp.common'
      include './com_18/nspc.common'
      include './com_18/pho_sch.common'
      include './com_18/plheight.common'
      include './com_18/tresh.common'

c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer , intent(in) :: ngt
      
      integer ip
      real*4 herb_seed,tree_seed
      
c-----------------------------------------------         
c=======================================================================
c     initialization
c=======================================================================      
      
       hole_herb = 0.
       hole_tree = 0.
       strat_herb = 0.
       strat_tree = 0.
       stratnew1 = 0.
       stratnew2 = 0.
       
       do ip = 1, npft0      
          
         if(ip.le.nherb+nbush) then
          strat_herb = strat_herb + frac(ip)
         else
          strat_tree = strat_tree + frac(ip)
         endif  

       enddo       
      
c=======================================================================
c     loss fraction
c=======================================================================        

      do ip = 1, npft0
              
       fracnew(ip) = ftot(ip)*frac(ip) 
               
      enddo
      
      do ip = 1, nherb+nbush
         stratnew1 = stratnew1 + fracnew(ip)
      enddo
      
      do ip = 1+nherb+nbush, npft0
         stratnew2 = stratnew2 + fracnew(ip)
      enddo
      
      do ip = 1, npft0
         perte(ip) = frac(ip)-fracnew(ip)
      enddo 

      
c      hole_herb = strat_herb-stratnew1
      hole_herb = frac_nat(ngt)-stratnew1
      if(hole_herb.lt.0.) hole_herb = 0.

c      hole_tree = strat_tree-stratnew2
      hole_tree = frac_nat(ngt)-stratnew2
      if(hole_tree.lt.0.) hole_tree = 0.
      
c=======================================================================
c     seed production
c=======================================================================
      
      do ip = 1, npft0              
        seed_prod(ip)  = 0.
        seed_estab(ip) = 0.
        dispin(ip)     = 0.
        dispout(ip)    = 0.
        frac_seed(ip)  = 0.
        density(ip)    = 0.
        if (suc_est(ip,ngt).gt.1.e-5) then
          density(ip) = 1.
          dispin(ip) = carb_init(ip,2)
          if(imig.eq.1.and.ip.eq.isp
!c         if(ip.eq.isp
     &       .and.irfg(ngt).ne.1) then
              density(ip) = 0.
              dispin(ip) = 0.
           endif
        endif

      end do

      do ip = 1, npft0

        seed_prod(ip) = 
     &          Fgdd5(ip)*frac(ip)*ynppf(ip)+dispin(ip)-dispout(ip)
        seed_estab(ip) = 
     &                  FTmmin(ip)*Fwatmin(ip)*pgerm(ip)*seed_prod(ip)

      enddo  
      
      herb_seed = 0.
      tree_seed = 0.
      do ip = 1, nherb+nbush
        herb_seed = herb_seed + density(ip)*seed_estab(ip)
      enddo
      
      do ip = nherb+nbush+1, npft0
        tree_seed = tree_seed + density(ip)*seed_estab(ip)
      enddo
      
      if(herb_seed.gt.0.) then
        do ip = 1, nherb+nbush
          frac_seed(ip) = hole_herb
     &                         *(density(ip)*seed_estab(ip)/herb_seed)  
        enddo
      endif
      
      if(tree_seed.gt.0.) then
        do ip = nherb+nbush+1, npft0
          frac_seed(ip) = hole_tree
     &                   *(density(ip)*seed_estab(ip)/tree_seed)
        enddo
      endif
      
      do ip = 1, npft0
        frac(ip) = fracnew(ip) + frac_seed(ip)  
      enddo

      return
      end subroutine new_frac