c=======================================================================
c***********************************************************************
      subroutine ponc_init
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c   This routine performs the initialisation of:
c  
c   ynpp    = yearly npp;
c   ygpp    = yearly leaf gpp;
c   ynep    = yearly nep;
c   xmnpp   = daily leaf npp (gc m-2 d-1);
c   xmgpp   = daily gross primary productivity (gc m-2 d-1);
c   zgpp(ip,iday,nlai) = daily gpp for the grid point .
c=======================================================================

      include './com_18/parameter.common'
      include './com_18/angppf.common'
      include './com_18/annppf.common'
      include './com_18/biomasse.common'
      include './com_18/burned.common'
      include './com_18/cmoiRmin.common'
      include './com_18/crops.common'      
      include './com_18/cte.common'
      include './com_18/dayres.common'
      include './com_18/fire_emi.common'      
      include './com_18/frac_change.common'
      include './com_18/fracc13.common'
      include './com_18/litiere.common'
      include './com_18/management.common'      
      include './com_18/monres.common'
      include './com_18/nspc.common'
      include './com_18/pnpp2.common'
      include './com_18/soil_marie.common'
      include './com_18/xvalues.common'

c-----------------------------------------------
c JLP ajouté pour implicit none
c

      integer iday,ip,ipool,kpool,m
      
c----------------------------------------------------
      do m = 1, nm
         xmgpp(m) = 0.
	 xmra(m) = 0.
         xmnpp(m) = 0.
         xmnep(m) = 0.
	 xmrh(m) = 0.
	 xmnbp(m) = 0.	 
	 xmemifire(m) = 0.
	 xmcharvest(m) = 0.
	 xmemiblit(m) = 0.
         xmlai(m) = 0.	 
         xmbiom(m) = 0.  
c  initialization of monthly variables of fire module
         xmPf(m) = 0.    
         xmPnf(m) = 1.
         xmfapar(m) = 0.
         xmfrac_burn(m) = 0.
         xmarea_burn(m) = 0.
      enddo

      do kpool = 0, 3
         ysoilr(kpool) = 0.
      end do

      do ip = 1, npft      
         if(ip.le.npft0.or.ip.ge.npft0+ncrop+1) ynppf(ip)   = 0.
         if(ip.le.npft0.or.ip.ge.npft0+ncrop+1) ygppf(ip)   = 0.
         ybiomf(ip)  = 0.
	 ybiomag(ip) = 0.
	 ybiombg(ip) = 0.
	 ybiomtot(ip) = 0.
         yfractf(ip) = 0.
         xlai_min(ip) = 0.
         xlai_max(ip) = 0.
         R_min(ip) = 0.
         xlai_moy(ip) = 0.
         fracnew(ip) = 0.
         frac_seed(ip) = 0.
         ycharvest(ip) = 0.
	 yield(ip) = 0.
	 yemifiref(ip) = 0.                             
      enddo

      do iday = 1, nd
         xdnpp(iday)   = 0.
         xdgpp(iday)   = 0.
         xdnep(iday)   = 0.
	 xdnbp(iday)   = 0.	 
	 xdemifire(iday) = 0.
	 xdcharvest(iday) = 0.	 
	 emi_burn_lit(iday) = 0.
         xdlai(iday)   = 0.
         xdbiom(iday)  = 0.      
         xdfract(iday) = 0.
         xdfapar(iday) = 0.
         xdgca(iday)   = 0.
         xdgci(iday)   = 0.

         do kpool = 1, 2
          xhum_prod(kpool,iday) = 0.
         end do
         do ip = 1, npft
            xlai(ip,iday) = 0.
	    xemifire(ip,iday) = 0.
	    xcharvest(ip,iday) = 0.
            do ipool = 1, npool
               xlit_prod(ip,ipool,iday) = 0.
               xlit_newprod(ip,ipool,iday) = 0.
               xlit_burn(ip,ipool,iday) = 0.
	       emi_burn_veg(ip,ipool,iday) = 0.
            enddo

               zgpp(ip,iday) = 0.
CNPP               znpp(ip,iday) = 0.
               zfract(ip,iday) = 0.
               zfh2o(ip,iday) = 0.
	       
         enddo

      enddo


      return
      end subroutine ponc_init