c=======================================================================
c***********************************************************************
      subroutine drainage(stept)
c***********************************************************************
c=======================================================================

c      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      implicit none
      include './com_18/parameter.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/drain.common'
      include './com_18/eco.common'
      include './com_18/smrd.common'
      real*4, intent(in) :: stept
      
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer j,kf,ks0,ni,num
      real*8  aa,aj,bb,bj,cj,dfn,drai,drdf,drdfb,drdft,drk0,dsm,ermax
     &      ,err,facrun,fnet,fnt,rdep,sl,sm,sm0,sma,smb,smfsi,smpo,smwpi
     &      ,taua,taub,taucri,taum,taumax,xi,yi
c
c-----------------------------------------------      
      
      dimension xi(nfmean),yi(nfmean),fnt(0:nfn)
     1         ,aj(0:nde),bj(0:nde),cj(nde+1),sl(nde+1,nde+2)
     2         ,drai(0:nfn),drdf(nfn-1)

      drk0 = 240.

      dfn = 1.
      fnt(nfmean) = 0.
      do kf = 1,nfmean
         if(kf.le.5)then
            fnt(nfmean+kf) = dfn*(2.**kf)
         else
            fnt(nfmean+kf) = fnt(nfmean+kf-1) * 1.5
         endif
         fnt(nfmean-kf) = -fnt(nfmean+kf)
      enddo
      fntmax = fnt(nfn)

      ni = 10
      ermax = 1.d-3*stept
      taumax = 1.5*stept
      taucri = (taumax+stept)/2.

         rdep = rootd
         aa = acd
         bb = bcd
         smwpi = smwp
         smfsi = smfs
         dsm = 1./float(nwa)

         do ks0 = 0,nwa

            wa0(ks0) = float(ks0)*dsm
            sm0 = smwpi+(smfsi-smwpi)*wa0(ks0)

            do kf = 0,nfn

               fnet = fnt(kf)
               if(fnet.le.0.)then
                  smpo = 0.
               else
                  smpo = bb/(dlog(fnet/drk0)-aa)
               endif

               sma = sm0
               if (smpo.lt.smwpi) then
                  smb = smwpi
                  facrun = 0.
               elseif (smpo.gt.smfsi) then
                  smb = smfsi
                  facrun = 1.
               else
                  smb = smpo
                  facrun = 1.
               endif
               taua = 0.
               call TAU(aa,bb,fnet,rdep,drk0,sm0,smb,taub,ni)
               if(taub.gt.taumax)taub=taumax
               if (taub.le.stept) then
                  sm = smb
                  drai(kf) = fnet*taub - rdep*(sm-sm0)
     &                     + facrun*(stept-taub)*drk0*dexp(aa+bb/sm)
                  goto 2000
               endif
               taum = 0.
               do num = 1,100
                  if(taum.le.taucri)then 
                     sm = sma + (smb-sma)
     &                  * dsqrt((stept-taua)/(taub-taua))
                  else
                     sm = sma + (smb-sma)
     &                  * (((stept-taua)/(taub-taua))**2.)
                  endif  
                  call TAU(aa,bb,fnet,rdep,drk0,sm0,sm,taum,ni)
                  if (taum.gt.taumax) taum=taumax
                  err = dabs(taum-stept)
                  if (err.le.ermax) then
                     drai(kf) = fnet*taum - rdep*(sm-sm0)
                     goto 2000
                  endif
                  if (taum.le.stept)then
                     sma = sm
                     taua = taum
                  else
                     smb = sm
                     taub = taum
                  endif
               enddo

               write(28,*)'SUBROUTINE drainage: too much iterations'
               write(28,*)'num:',num
               write(28,*)'sma:',sma,' taua:',taua
               write(28,*)'smb:',smb,' taub:',taub
               write(28,*)'sm:',sm,' taum:',taum
               write(28,*)'Program stop'
               stop

2000           continue
               if(drai(kf).lt.0.)drai(kf)=0.
            enddo

            do kf=1,nfn-1
               drdfb=(drai(kf)-drai(kf-1))/(fnt(kf)-fnt(kf-1))
               drdft=(drai(kf+1)-drai(kf))/(fnt(kf+1)-fnt(kf))
               drdf(kf) = (drdfb+drdft)/2.
            enddo

            do kf=1,nfmean
               xi(kf) = fnt(kf)
               yi(kf) = drdf(kf)
            enddo 
            call polfit(xi,yi,nfmean,aj,nde,err,cj,sl)

            do kf=nfmean,nfn-1
               xi(kf-nfmean+1) = fnt(kf)
               yi(kf-nfmean+1) = drdf(kf)
            enddo 
            call polfit(xi,yi,nfmean,bj,nde,err,cj,sl)

            ajdr(0,ks0) = drai(nfmean)
            bjdr(0,ks0) = drai(nfmean)
            do j=1,nde+1 
               ajdr(j,ks0) = aj(j-1)/float(j)
               bjdr(j,ks0) = bj(j-1)/float(j)
            enddo

         enddo

      return
      end subroutine drainage