c=======================================================================
c***********************************************************************
      subroutine esat (tk,es)
c***********************************************************************
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none

c=======================================================================
c   This subroutine calculates saturation vapour pressure of H2O.
c   INPUT :  tk = temperature [K]
c   OUTPUT : es = saturated vapour pressure of H2O [Pa]
c=======================================================================
      include './com_18/parameter.common'
      include './com_18/envi.common'
      include './com_18/temper.common'
      real*4, intent(in) :: tk
      real*4, intent(out) :: es

      if (tk.ge.temp0) then
         es = 100.*exp(-asat/tk-bsat*alog(tk)+csat)
      else
         es = psat0*exp(eaice*(tk-temp0)/(rgas*tk*temp0))
      endif

      return
      end subroutine esat