c=======================================================================
c***********************************************************************
      subroutine ode(tbegin,tend,y,stept,niter,ipr)
c***********************************************************************
c=======================================================================
c      implicit double precision (a-h,o-z)
      implicit none
      include './com_18/parameter.common'
      include './com_18/coldrv.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer i,ipr,iter,j,niter
      real*8  drv,time,y,ynew
c
c-----------------------------------------------      
      real*4 tbegin,tend,stept
      dimension y(nequat), ynew(nequat), drv(nequat)

c   reading of the control parameters :
c   stept  : integration step (constant during the whole simulation)
c   niter  : maximum number of correction iterations
c   tbegin : initial time
c   tend   : final   time
c   ipr    : unite pour les impressions
c ----------------------------------------------------------------------

c initial conditions
c ----------------------------------------------------------------------
      time = tbegin
      call timdep(stept,time)


c the integration is performed with "runge-kutta" for the first
c "norder" steps :
c derivatives "drv" are computed at the current time value (givedrv)
c and kept in "tbldrv" whose back differences will be computed in
c "initbdo".
c "runkut4" computes "y" for the next time value.
c ----------------------------------------------------------------------

      do j = norder,1,-1
         call givedrv(stept,time,y,drv)
         call check(stept,time,y,drv)
         call printing(ipr,time,y,drv)
         do i = 1, nequat
            tbldrv(i,j) = drv(i)
         enddo
         call runkut4(stept,time,y,drv)
         time = time + stept
         call timdep(stept,time)
      enddo
      call initbdo

c   prediction-correction scheme begins :
c ----------------------------------------------------------------------
9990  continue
      call givedrv(stept,time,y,drv)
      call check(stept,time,y,drv)
      call printing(ipr,time,y,drv)
      call backdiff(drv)
      call bashfor(stept,drv,y,ynew)     
      time = time + stept
      call timdep(stept,time)
      call remember(drv)
      do iter = 1, niter
         call givedrv(stept,time,ynew,drv)
         call backdiff(drv)
         call moulton(stept,drv,y,ynew)
      enddo
      do i = 1, nequat
         y(i) = ynew(i)

      enddo
      if(time .lt. tend) goto 9990

CVC      call givedrv(stept,time,y,drv)
CVC      call check(stept,time,y,drv)
      call printing(ipr,time,y,drv)

      return
      end subroutine ode