c=======================================================================
c***********************************************************************
      subroutine timdep(stept,time)
c***********************************************************************
c=======================================================================
c      implicit double precision (a-h,o-z)
      implicit none

      include './com_18/parameter.common'
      include './com_18/climin0.common'
      include './com_18/climin.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/eco.common'
      include './com_18/nspc.common'
      include './com_18/solpar.common'
      include './com_18/varnow.common'
      include './com_18/varday.common'
      include './com_18/vegfr.common'
      include './com_18/xlaic.common'
      real*4, intent(in) :: stept

c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer idn,idn1,idn2,ih,ip,j,jh,ngf,ngf2,ny0
      
      real*8  dn,strfac,tcor,tem1,tem2,time,tmin10,tnmin1,tnmin2,wacor
     &      ,wat10
c
c-----------------------------------------------


      ny0 = int(time/float(nd)+0.000001)+1
      dn  = time - float(ny0-1) * float(nd)
      idn=int(dn+1.00001)

         preci=prc(idn)
         temi=tcel(idn)
         delti=tdiff(idn)
         shi=sunhour(idn)
         hai=rhu(idn)
         windi=win(idn)

         do ih=0,nh2
            solg(ih) = solday(idn,ih)
            ftrs(ih) = ftrday(idn,ih)
            xmu(ih) = xmuday(idn,ih)
         enddo

         do ih=nh2+1,nh
            jh = nh+1-ih
            solg(ih) = solday(idn,jh)
            ftrs(ih) = ftrday(idn,jh)
            xmu(ih) = xmuday(idn,jh)          
         enddo 


c   tmin10: average min. temp. of the last 2*ngf2 days 
c   wat10 : average soil water of the last 2*ngf2 days 
c   wat10 : average soil water of the last 2*ngf2 days 
c   tem1  : average temp. of the last period of ngf2 days 
c   tem2  : average temp. of the last but one period of ngf2 days 
c ----------------------------------------------------------------------

         tem1 = 0.
         tem2 = 0.
         tmin10 = 0.
         wat10 = 0.
         ngf2 = 7
         ngf = 2*ngf2
         do j = 1,ngf2
            idn1 = idn-j
            if (idn1.le.0) idn1=idn1+nd
            idn2 = idn1-ngf2
            if (idn2.le.0) idn2=idn2+nd
            tem1 = tem1+tcel(idn1)/ngf2
            tem2 = tem2+tcel(idn2)/ngf2
            tnmin1=tcel(idn1)-tdiff(idn1)/2.
            tnmin2=tcel(idn2)-tdiff(idn2)/2.
            tmin10 = tmin10 + (tnmin1+tnmin2)/ngf
            wat10 = wat10 + (aswday(idn1)+aswday(idn2))/ngf
         enddo

c   grflx : heat flux into the ground H [W m-2] 
c   (Mintz and Walker, J. Appl. Met., 32, p. 1313, 1993) 
c ----------------------------------------------------------------------

       grflx = 48.426 * (tem1-tem2) / (ngf2*stept)

c   plai(ip) : lai of plant type ip over grid cell igr
c  [m2/m2] 
c ----------------------------------------------------------------------

         wacor = wat10/0.25
         if (wacor.ge.1.)wacor=1.
         if (wacor.le.0.)wacor=0. 

         do ip=1,npft
            tcor = (tmin10-t1pft(ip))/(t2pft(ip)-t1pft(ip))
            if (tcor.ge.1.)tcor=1.
            if (tcor.le.0.)tcor=0.
            strfac = min(wacor,tcor)
            plai(ip)=xlmin(ip)+strfac*(xlmax(ip)-xlmin(ip))
         enddo

      return
      end subroutine timdep