       SUBROUTINE CHECK_AND_OPEN_FILE(
     &    incdf, iunit, icyr, str_filext, kext, str_ext,
     &    str_ncfile_name, str_descript,
     &    str_ncvar_name, 
     &    ncfile_id, ncvar_id)
        IMPLICIT NONE

        INTEGER, INTENT(IN)          :: incdf
	    INTEGER, INTENT(IN)          :: iunit
	    INTEGER, INTENT(IN)          :: icyr
        CHARACTER(LEN=*), INTENT(IN) :: str_filext
        INTEGER, INTENT(IN)          :: kext
        CHARACTER(LEN=*), INTENT(IN) :: str_ext	
        CHARACTER(LEN=*), INTENT(IN) :: str_ncfile_name
        CHARACTER(LEN=*), INTENT(IN) :: str_descript
        CHARACTER(LEN=*), INTENT(IN) :: str_ncvar_name
        INTEGER, INTENT(OUT)         :: ncfile_id
        INTEGER, INTENT(OUT)         :: ncvar_id

        CHARACTER(LEN=245) :: filename
        LOGICAL            :: l_fileexists = .FALSE.
        INTEGER :: istatus


c        write(*,*)'filext: ', str_filext(1:kext)
c	write(*,*)' kext: ', kext



        l_fileexists=.FALSE.
        IF (icyr == 0) THEN
          filename = TRIM(str_ncfile_name)
          INQUIRE(FILE=filename, EXIST=l_fileexists)
        ELSE
	  IF (incdf == 1) THEN
           filename = TRIM(str_ncfile_name)//str_filext(1:kext)//'.nc'
           INQUIRE(FILE=filename, EXIST=l_fileexists)
           IF(.NOT.l_fileexists) THEN
            filename = TRIM(str_ncfile_name)//str_filext(1:kext)//'.nc4'
            INQUIRE(FILE=filename, EXIST=l_fileexists)
           ENDIF
	  ELSE
	   filename = 
     &        TRIM(str_ncfile_name)//str_filext(1:kext)//TRIM(str_ext)
           INQUIRE(FILE=filename, EXIST=l_fileexists)
	  ENDIF
        ENDIF

        IF (.NOT. l_fileexists) THEN

          WRITE(*,*) 'No file found for ' // TRIM(str_descript) // '!'
          WRITE(*,*) 'Requested: "' // TRIM(str_ncfile_name) //'"'	  
          WRITE(*,*) 'Tested "' // TRIM(str_ncfile_name) // '"'
	  IF (incdf == 1) THEN
           WRITE(*,*) '       "' // TRIM(str_ncfile_name) //
     &               str_filext(1:kext) // '.nc' // '"'
           WRITE(*,*) '       "' // TRIM(str_ncfile_name) //
     &               str_filext(1:kext) // '.nc4' // '"'
          ELSE
	   WRITE(*,*) '       "' // TRIM(str_ncfile_name) //
     &               str_filext(1:kext) //TRIM(str_ext)
          ENDIF
          WRITE(*,*) 'without success -- aborting!'
          CALL ABORT()

        ELSE
          
	  IF (incdf == 1) THEN
           istatus = NF_OPEN(filename, NF_NOWRITE, ncfile_id)
           IF (istatus /= NF_NOERR)
     &       CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

           istatus = NF_INQ_VARID(ncfile_id, TRIM(str_ncvar_name), 
     &              ncvar_id)
           IF (istatus /= NF_NOERR)
     &       CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))
          ELSE
	   OPEN(iunit,FILE=filename,STATUS='old')
	  ENDIF

        ENDIF
        
	

        END SUBROUTINE CHECK_AND_OPEN_FILE