c=======================================================================
c***********************************************************************
      subroutine koppen2(climate)
c***********************************************************************
c=======================================================================
      implicit none
      include './com_18/parameter.common'
      include './com_18/climkop.common'
      include './com_18/coord.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer j,m,md,mdry,msummer,mtest1,mtest2,mwet,mwinter,n,ns,nwi
      real*4  g,pa,pmin,psmax,psmin,psummer,ptest1,ptest2,ptest3,pwinter
     &      ,pwmax,pwmin,ta,tmax,tmin
c
c-----------------------------------------------

      dimension msummer(3),mwinter(3), mwet(3), mdry(5)
      character*1 q
      character*2 u
      character*3 climate

      q = ' '
      u = '  '
      climate = '???'

      if(ylati .ge. 0.) then
         mwinter(1) =  1
         msummer(1) =  7
      else
         mwinter(1) =  7
         msummer(1) =  1
      endif

      do j=1,2
         mwinter(1+j) = mwinter(1) + j
         msummer(1+j) = msummer(1) + j
      enddo

      pa = 0.
      ta = 0.
      do m = 1, nm
         pa = pa +  prckop(m)
         ta = ta + tcelkop(m)
      enddo
      ta = ta/12.

c=======================================================================
c  B : Dry Climates
c      Bw : Desert Climate 
c      Bs : Steppes Climate 
c=======================================================================

 1020 continue
      pwinter = 0.
      psummer = 0.
      do j = 1, 3
         pwinter = pwinter + prckop(mwinter(j))
         psummer = psummer + prckop(msummer(j))
      enddo

      ptest1 = 2*ta
      ptest2 = 2*ta + 14.
      ptest3 = 2*ta + 28.
      if(      (0.1*pa .le. ptest1) .and. (pwinter .ge. 0.7*pa) ) then
         g = ptest1
      elseif( (0.1*pa .le. ptest3) .and. (psummer .ge. 0.7*pa) ) then
         g = ptest3
      elseif(  0.1*pa .le. ptest2) then
         g = ptest2
      else
         goto 1010
      endif

      if(pa .le. 0.5*g) then
          u = 'Bw'
      else
          u = 'Bs'
      endif
      if(ta .ge. 18.) then
          climate = u//'h'
      else
          climate = u//'k'
      endif
      return

c=======================================================================
c  A : Tropical Climates
c      Af : Tropical Rainy Climate
c      Am : Tropical Wet Climate
c      Aw : Dry Monsoon Climate
c      As : Dry Monsoon Climate
c=======================================================================

 1010 continue

      pmin =  prckop(1)
      tmin = tcelkop(1)
      do m = 2, nm
         if( prckop(m) .lt. pmin) pmin =  prckop(m)
         if(tcelkop(m) .lt. tmin) tmin = tcelkop(m)
      enddo

      if(tmin .lt. 18.) goto 1034

      if(pmin .ge. 60.) then
         climate = 'Af'
         return
      endif

      if(pmin .gt. 100.-pa/25.) then
         climate = 'Am'
         return
      endif

      call dryseas(prckop,mwet)

      do j = 1, 3
         if(mwinter(j) .eq. mwet(1) .or.
     &      mwinter(j) .eq. mwet(3)) then
            climate = 'Aw'
            return
         endif
      enddo

      do j = 1, 3
         mtest2 = msummer(j) + 1
         if(mtest2 .eq. 13) mtest2 =  1
         if(msummer(j) .eq. mwet(1) .or.
     &      msummer(j) .eq. mwet(3) .or.
     &          mtest2 .eq. mwet(1) .or.
     &          mtest2 .eq. mwet(3)) then
            climate = 'As'
            return
         endif
      enddo

      do j = 1, 3
         mtest1 = mwinter(j) + 1
         if(mtest1 .eq. 13) mtest1 = 1
         if(mtest1 .eq. mwet(1) .or.
     &      mtest1 .eq. mwet(3)) then
            climate = 'Aw'
            return
         endif
      enddo

      call humiseas(prckop,mdry)

      nwi = 0
      ns = 0
      do md = 1, 5
         do j = 1, 3
            if(mdry(md) .eq. mwinter(j)) nwi = nwi + 1
            if(mdry(md) .eq. msummer(j)) ns = ns + 1
         enddo
      enddo

      if(nwi .gt. ns) then
         climate = 'Aw'
         return
      endif

      if(nwi .lt. ns) then
         climate = 'As'
         return
      endif

c=======================================================================
c  C : Mid-Latitude Rainy Climate
c      Cs : with dry summer
c      Cw : with dry winter
c      Cf : precipitation in all seasons
c  D : Continental Climate
c     (Ds : with dry summer)
c      Dw : with dry winter
c      Df : precipitation in all seasons
c=======================================================================

 1034 continue

      tmax = tcelkop(1)
      do m = 2, nm
         if(tcelkop(m) .gt. tmax) tmax = tcelkop(m)
      enddo

      if(tmax .ge. 10.) then
         if(    (tmin .ge. -3.) .and. (tmin .lt. 18.) ) then
            q = 'C'
         elseif(tmin .lt. -3.) then
            q = 'D'
         else
            goto 1050
         endif
      else
         goto 1050
      endif

      if(pmin .gt. 30.) then
         u = q//'f'
      else
         pwmin = prckop(mwinter(1))
         pwmax = prckop(mwinter(1))
         psmin = prckop(msummer(1))
         psmax = prckop(msummer(1))
         do j = mwinter(2), mwinter(3)
            if(prckop(j) .lt. pwmin) pwmin = prckop(j)
            if(prckop(j) .gt. pwmax) pwmax = prckop(j)
         enddo
         do j = msummer(2), msummer(3)
            if(prckop(j) .lt. psmin) psmin = prckop(j)
            if(prckop(j) .gt. psmax) psmax = prckop(j)
         enddo

         if(     psmax .gt. 10*pwmin) then
            u = q//'w'
         elseif(pwmax .gt.  3*psmin .and. pmin .le. 30.) then
            u = q//'s'
         else
            u = q//'f'
         endif
      endif

      if(tmax .ge. 22.) then
         climate = u//'a'
         return
      endif

      n = 0
      do m = 1, nm
         if(tcelkop(m) .gt. 10.) n = n + 1
      enddo

      if(n .ge. 4) then
         climate = u//'b'
         return
      endif

      if((n .ge. 1) .and. (n .le. 3)) then
         climate = u//'c'
         return
      endif

      if(tmin .lt. -38.) then
         climate = u//'d'
         return
      endif

c=======================================================================
c  E : Polar Climates
c      ET : Tundra climate
c      EF : Snow climate
c=======================================================================

 1050 continue
      if(tmax .le. 10.) then
         if(tmax .gt. 0.) then
            climate = 'ET'
         else
            climate = 'EF'
         endif
      else
         write(*,*) ' '
         write(*,*) ' problem in koppen2 : climate = ', climate
         write(*,*) ' x, y = ', ylongi, ylati
         write(*,*) ' tmp = ', tcelkop
         write(*,*) ' ppt = ',  prckop
         write(*,*) ' '
         stop
      endif

      return
      end subroutine koppen2