c=======================================================================
c***********************************************************************
      subroutine open_file(iread)
c***********************************************************************
c=======================================================================

      USE MOD_NETCDFCARAIB
      IMPLICIT NONE
      
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/climin0.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/files_car.common'
      include './com_18/files_ext.common'
      include './com_18/files_ibm.common'
      include './com_18/fileunits.common'      
      include './com_18/input_par.common'
      include './com_18/icyr.common'      
      include './com_18/iprt.common'      
      include './com_18/management.common'
      include './com_18/netcdf_name.common'
      include './com_18/netcdf_par.common'                  
      include './com_18/nspc.common'
      include './com_18/co2.common'
      include './com_18/prt_ctrl.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer i,incdf_winb,ncpos_i,ncpos_j
      integer kexta,kextb,kexti,kexto,kextlu,kf
c
c-----------------------------------------------

c// BEGIN
      CHARACTER(LEN=*), PARAMETER :: fn_caraib = __FILE__ 
c// END
      character*30 ydat
c      character*20 filext
      character*245 filename
      character*5 filexta,filextb
      character*6 dndata
      integer iread
      integer r100,r4,icentury

c// BEGIN
      INTEGER :: istatus
      LOGICAL :: l_fileexists

      ncpos_i = 0                   ! Initialise Netcdf positions
      ncpos_j = 0
c// END

      
      if (num_ncdf.ge.1) then
        read(5,'(a30,a16,1x,a16,1x,a120,1x,a6)')
     &                         ydat,filexto,filextlu,filexti,dndata
	read(dndata,*)idayct
      else
        read(5,'(a30,a16,1x,a16,1x,a120)')ydat,filexto,filextlu,filexti
      endif
      

      call charlen(filexti,kexti)
      call charlen(filexto,kexto)
      call charlen(filextlu,kextlu)      

      read(ydat,*)myear,pco2_rd,nys,ipr_clim,iyprt
c      write(*,*)'Reading year: ',myear
       
      nyear2 = myear

c Determination of leap years according to year number myear   
c -----------------------------------------------------------
c If ileap = 1, myear must be set to the year number in the Gregorian
c calendar, otherwise myear can be set to any integer value
c     nd = number of days in the current year

      if (ileap.eq.1) then
        r100 = mod(myear,100)
        if (r100.eq.0) then
         icentury = myear/100
         r4 = mod(icentury,4)
        else     
         r4 = mod(myear,4)
        endif 
        if (r4.eq.0) then 
         nd = 366 
        else
	 nd = 365
        endif
        call monthparam
      endif

c Cumulated day number since a given date (e.g., 1/1/1860) 
c --------------------------------------------------------
c   idayct = cumulated day number on the 31st of December 
c            of the previous year (initiated in subroutine open_input5
c            and calculated in main program)
c   idayct + 1 -> cumulated day number on the 1st of January 
c                 of the current year
c   idayct + nd -> cumulated day number on the 31st of December 
c                 of the current year
       
c      write(*,*)'Year: ',myear,' idayct:',idayct      
      
      open(1,file=filtxt,status='old')
      
      if (nyear.eq.1.and.iclim.eq.1) then 
       open(666,file=filclim,status='old')
      endif
      
      if(iclim.eq.0) then
        iclim_cal = 0
      else
        if(nyear.eq.1.or.nyear2.eq.ibb) then
         read(666,*) iaa,ibb,filexta,filextb
         iclim_cal = 0
        else
         iclim_cal = 1
        endif
        call charlen(filexta,kexta)
        call charlen(filextb,kextb)
      endif
      
      if(iclim_cal.eq.0) then

! Temperature -- unit 2
        iunit_tema = 2
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_tem, iunit_tema, icyr_tem, filexti, kexti, extin,
     &    filtem, 'temperature climatology (i)',
     &    ncname_tem, 
     &    ncid_filtema, ncvar_tema)
       
  
! Temperature difference -- former unit 3
c
c Open 2 files: Tmax and Tmin and calculate the difference Tmax-Tmin (idtem = 1)
c Open twice DTEM = Tmax-Tmin. 
c The temperature difference has been calculated externally (idtem = 0)

! TMAX OR DTEM
        iunit_dtaa = 3
	CALL CHECK_AND_OPEN_FILE(
     &    incdf_dta, iunit_dtaa, icyr_dta, filexti, kexti, extin,
     &    fildta, 'TMAX or temperature difference climatology (i.a)',
     &    ncname_dta, 
     &    ncid_fildtaa, ncvar_dtaa)

! TMIN     
        IF (idtem.eq.1) then
         iunit_dtba = 301
	 CALL CHECK_AND_OPEN_FILE(
     &    incdf_dtb, iunit_dtba, icyr_dtb, filexti, kexti, extin,
     &    fildtb, 'TMIN climatology (i.b)',
     &    ncname_dtb, 
     &    ncid_fildtba, ncvar_dtba)
        ENDIF

! Precipitation -- former unit 4
        iunit_prca = 4
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_prc, iunit_prca, icyr_prc, filexti, kexti, extin,
     &    filprc, 'precipitation climatology (i)',
     &    ncname_prc, 
     &    ncid_filprca, ncvar_prca)

! Sunshine Relative Hours -- former unit 7
        iunit_shia = 7
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_shi, iunit_shia, icyr_shi, filexti, kexti, extin,
     &    filshi, 'sunshine relative hours climatology (i)',
     &    ncname_shi, 
     &    ncid_filshia, ncvar_shia)

! Relative Humidity -- former unit 8
        iunit_rhua = 8
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_rhu, iunit_rhua, icyr_rhu, filexti, kexti, extin,
     &    filrhu, 'relative humidity climatology (i)',
     &    ncname_rhu, 
     &    ncid_filrhua, ncvar_rhua)
  
! Wind -- former unit 9
        iunit_wina = 9
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_win, iunit_wina, icyr_win, filexti, kexti, extin,
     &    filwin, 'wind climatology (i)',
     &    ncname_win, 
     &    ncid_filwina, ncvar_wina)


      ELSE

      
! Temperature -- former unit 2
        iunit_tema = 2
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_tem, iunit_tema, icyr_tem, filexta, kexta, extin,
     &    filtem, 'temperature climatology (i)',
     &    ncname_tem, 
     &    ncid_filtema, ncvar_tema)

! Temperature difference -- former unit 3
c Open 2 files: Tmax and Tmin and calculate the difference Tmax-Tmin (idtem = 1)
c Open twice DTEM = Tmax-Tmin. 
c The temperature difference has been calculated externally (idtem = 0)

! TMAX
        iunit_dtaa = 3
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_dta, iunit_dtaa, icyr_dta, filexta, kexta, extin,
     &    fildta, 'temperature difference climatology (i)',
     &    ncname_dta, 
     &    ncid_fildtaa, ncvar_dtaa)
     
! TMIN
        IF (idtem.eq.1) then
         iunit_dtba = 301
         CALL CHECK_AND_OPEN_FILE(
     &    incdf_dtb, iunit_dtba, icyr_dtb, filexta, kexta, extin,
     &    fildtb, 'temperature difference climatology (i)',
     &    ncname_dtb, 
     &    ncid_fildtba, ncvar_dtba)
        ENDIF

! Precipitation -- former unit 4
        iunit_prca = 4
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_prc, iunit_prca, icyr_prc, filexta, kexta, extin,
     &    filprc, 'precipitation climatology (i)',
     &    ncname_prc, 
     &    ncid_filprca, ncvar_prca)

! Sunshine Relative Hours -- former unit 7
        iunit_shia = 7
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_shi, iunit_shia, icyr_shi, filexta, kexta, extin,
     &    filshi, 'sunshine relative hours climatology (i)',
     &    ncname_shi, 
     &    ncid_filshia, ncvar_shia)

! Relative Humidity -- former unit 8
        iunit_rhua = 8
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_rhu, iunit_rhua, icyr_rhu, filexta, kexta, extin,
     &    filrhu, 'relative humidity climatology (i)',
     &    ncname_rhu, 
     &    ncid_filrhua, ncvar_rhua)

! Former unit 9
        iunit_wina = 9
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_win, iunit_wina, icyr_win, filexta, kexta, extin,
     &    filwin, 'wind climatology (a)',
     &    ncname_win, 
     &    ncid_filwina, ncvar_wina)


! Former unit 222
        iunit_temb = 222
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_tem, iunit_temb, icyr_tem, filextb, kextb, extin,
     &    filtem, 'temperature climatology (b)',
     &    ncname_tem, 
     &    ncid_filtemb, ncvar_temb)

! Former unit 333
c Open 2 files: Tmax and Tmin and calculate the difference Tmax-Tmin (idtem = 1)
c Open twice DTEM = Tmax-Tmin. 
c The temperature difference has been calculated externally (idtem = 0)

! TMAX
        iunit_dtab = 333
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_dta, iunit_dtab, icyr_dta, filextb, kextb, extin,
     &    fildta, 'temperature difference climatology (a.b)',
     &    ncname_dta, 
     &    ncid_fildtab, ncvar_dtab)

! TMIN
        IF (idtem.eq.1) then
         iunit_dtbb = 311
         CALL CHECK_AND_OPEN_FILE(
     &    incdf_dtb, iunit_dtbb, icyr_dtb, filextb, kextb, extin,
     &    fildtb, 'temperature difference climatology (b.b)',
     &    ncname_dtb, 
     &    ncid_fildtbb, ncvar_dtbb)
        ENDIF
	
! Former unit 444
        iunit_prcb = 444
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_prc, iunit_prcb, icyr_prc, filextb, kextb, extin,
     &    filprc, 'precipitation climatology (b)',
     &    ncname_prc, 
     &    ncid_filprcb, ncvar_prcb)

! Former unit 777
        iunit_shib = 777
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_shi, iunit_shib, icyr_shi, filextb, kextb, extin,
     &    filshi, 'sunshine relative hours climatology (b)',
     &    ncname_shi, 
     &    ncid_filshib, ncvar_shib)

! Former unit 888
        iunit_rhub = 888
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_rhu, iunit_rhub, icyr_rhu, filextb, kextb, extin,
     &    filrhu, 'relative humidity climatology (b)',
     &    ncname_rhu, 
     &    ncid_filrhub, ncvar_rhub)

! Former unit 999
        iunit_winb = 999
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_winb, iunit_winb, icyr_win, filextb, kextb, extin,
     &    filwin, 'wind climatology (b)',
     &    ncname_win, 
     &    ncid_filwinb, ncvar_winb)

      endif
      
      if (num_ncdf.ge.1) then
      
       if (incdf_win.eq.1) then 
         ncid_filcooa = ncid_filwina
	 ncvar_cooa = ncvar_wina
       elseif (incdf_tem.eq.1) then
         ncid_filcooa = ncid_filtema
	 ncvar_cooa = ncvar_tema
       elseif (incdf_dta.eq.1) then
         ncid_filcooa = ncid_fildtaa
	 ncvar_cooa = ncvar_dtaa	 
       elseif (incdf_prc.eq.1) then
         ncid_filcooa = ncid_filprca
	 ncvar_cooa = ncvar_prca
       elseif (incdf_shi.eq.1) then
         ncid_filcooa = ncid_filshia
	 ncvar_cooa = ncvar_shia
       elseif (incdf_rhu.eq.1) then
         ncid_filcooa = ncid_filrhua
	 ncvar_cooa = ncvar_rhua
       elseif ((idtem.eq.1).and.(incdf_dtb.eq.1)) then
         ncid_filcooa = ncid_fildtba
	 ncvar_cooa = ncvar_dtba
       elseif (incdf_tclim.eq.1) then
         ncid_filcooa = ncid_filtclima
	 ncvar_cooa = ncvar_tclima
       elseif (incdf_pclim.eq.1) then
         ncid_filcooa = ncid_filpclima
	 ncvar_cooa = ncvar_pclima	 	 	 	 	 
       else 
         write (*,*) 'Wrong value of netcdf parameters incdf_xxxx'       
         write (*,*) 'Aborting'
       endif
       
c// BEGIN
c// provisional code, to be discarded once all will have been
c// converted to NetCDF
c// Now that at least one NetCDF file is open, we can read in the lon/lat,
c// data; if this has not been done before.
      
 

       IF (.NOT. l_gridinit_done) THEN

                                     ! Inquire for id of dimension 'lon'
        istatus = NF_INQ_DIMID(ncid_filcooa, 'lon', ncdim_lon)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for length of dimension 'lon'
        istatus = NF_INQ_DIMLEN(ncid_filcooa, ncdim_lon, nclen_lon)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for id of variable 'lon'
        istatus = NF_INQ_VARID(ncid_filcooa, 'lon', ncvar_lon)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Allocate space for dimension variable
        ALLOCATE(zlon(nclen_lon))
                                     ! Read in values for dimension 'lon' variable
        istatus = NF_GET_VAR_DOUBLE(ncid_filcooa, ncvar_lon, zlon)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))
      
                                     ! Set typical maximum uncertainty for longitude spacing
        zdel_lon = ABS(zlon(2)-zlon(1))/100D0
        ncpos_lon = 1
                                     ! Inquire for id of dimension 'lat'
        istatus = NF_INQ_DIMID(ncid_filcooa, 'lat', ncdim_lat)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for length of dimension 'lat'
        istatus = NF_INQ_DIMLEN(ncid_filcooa, ncdim_lat, nclen_lat)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for id of variable 'lat'
        istatus = NF_INQ_VARID(ncid_filcooa, 'lat', ncvar_lat)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))
                                     ! Allocate space for dimension variable
        ALLOCATE(zlat(nclen_lat))
                                     ! Read in values for dimension 'lat' variable
        istatus = NF_GET_VAR_DOUBLE(ncid_filcooa, ncvar_lat, zlat)
          IF (istatus /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Set typical maximum uncertainty for latitude spacing
        zdel_lat = ABS(zlon(2)-zlon(1))/100D0
        ncpos_lat = 1

        l_gridinit_done = .TRUE.

       ENDIF
      
c      IF (.NOT. l_timeinit_done) THEN
       IF (idaily_in /= 0) THEN
      
      ! Inquire for id of dimension 'time'
        istatus = NF_INQ_DIMID(ncid_filcooa, 'time', ncdim_time)
        IF (istatus /= NF_NOERR)
     &    CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for length of dimension 'time'
        istatus = NF_INQ_DIMLEN(ncid_filcooa, ncdim_time, nclen_time)
        IF (istatus /= NF_NOERR)
     &    CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

                                     ! Inquire for id of variable 'time'
        istatus = NF_INQ_VARID(ncid_filcooa, 'time', ncvar_time)
        IF (istatus /= NF_NOERR)
     &    CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))
                                     ! Allocate space for dimension variable
        ALLOCATE(ztime(nclen_time))
                                     ! Read in values for dimension 'time' variable
        istatus = NF_GET_VAR_DOUBLE(ncid_filcooa, ncvar_time, ztime)
        IF (istatus /= NF_NOERR)
     &    CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-2))

c   Search for idayct
        ncpos_time = 0
c	write(*,*)'myear= ',myear,' idayct= ',idayct
	
        DO i=1,nclen_time
	        
		ztime(i) = int(ztime(i))
		
	        IF (ztime(i) == idayct) THEN
	          ncpos_time = i
	          EXIT
	        ENDIF 

        ENDDO                                     
        

	IF (ncpos_time == 0) THEN
	
	        WRITE(*,*) 'idayct =', idayct,
     &              ' cannot be found in file, ABORTING'
          CALL ABORT()
	
	ENDIF
	
	DEALLOCATE(ztime)
	ncdim_time = 0
	nclen_time = 0
	ncvar_time = 0

       ELSE
	
        ncpos_time = 1
	
       ENDIF
        
c	    l_timeinit_done = .TRUE.
	
c      ENDIF
c// END

      endif !(num_ncdf.ge.1)
      
      if (ipr_clim.ne.0) then
       if (iprt_tem.ne.0) then
        filename = TRIM(filotem)//filexto(1:kexto)//extin(1:kextin)
        open(502,file=filename)
       endif
       if (iprt_dte.ne.0) then
        filename = TRIM(filodte)//filexto(1:kexto)//extin(1:kextin)
        open(503,file=filename)
       endif
       if (iprt_prc.ne.0) then
        filename = TRIM(filoprc)//filexto(1:kexto)//extin(1:kextin)
        open(504,file=filename)
       endif
       if (iprt_shr.ne.0) then
        filename = TRIM(filoshr)//filexto(1:kexto)//extin(1:kextin)
        open(507,file=filename)
       endif
       if (iprt_rhu.ne.0) then
        filename = TRIM(filorhu)//filexto(1:kexto)//extin(1:kextin)
        open(508,file=filename)
       endif
       if (iprt_win.ne.0) then              
        filename = TRIM(filowin)//filexto(1:kexto)//extin(1:kextin)
        open(509,file=filename)
       endif       
      endif
      
c --- CAUTION: time extension (year) is filexto or filextlu for management, fire, 
c     land use, LU species, sowing dates and cultivar files, depending on icyr
c ------------------------------------------------------------------------------      

      if (imanag.eq.1) then
       call charlen(filemanag,kf)
       if (icyr_manag.eq.0) then
        filename=filemanag(1:kf)
       elseif (icyr_manag.eq.1) then
        filename=filemanag(1:kf)//filexto(1:kexto)//extin(1:kextin)
       else	
        filename=filemanag(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
       endif
       open(92,file=filename,status='old')
      endif
      
      if (ifire.eq.1) then
       call charlen(fillight,kf)
       if (icyr_light.eq.0) then
        filename=fillight(1:kf)
       elseif (icyr_light.eq.1) then
        filename=fillight(1:kf)//filexto(1:kexto)//extin(1:kextin)	
       else
        filename=fillight(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
       endif
       open(93,file=filename,status='old')
      endif
      
      if (ilu.eq.1) then      
       call charlen(fillanduse,kf)
       if (icyr_landuse.eq.0) then
        filename=fillanduse(1:kf)
       elseif (icyr_landuse.eq.1) then
        filename=fillanduse(1:kf)//filexto(1:kexto)//extin(1:kextin)	
       else
        filename=fillanduse(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
       endif
       open(94,file=filename,status='old')
      
       if (ilusp_rd.eq.1) then      
        call charlen(fillusp,kf)
        if (icyr_lusp.eq.0) then
         filename=fillusp(1:kf)
        elseif (icyr_lusp.eq.1) then
         filename=fillusp(1:kf)//filexto(1:kexto)//extin(1:kextin)
	else
         filename=fillusp(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
        endif
        open(194,file=filename,status='old')
       endif
      
       if (isowd_rd.eq.1) then      
        call charlen(filsowd,kf)
        if (icyr_sowd.eq.0) then
         filename=filsowd(1:kf)
        elseif (icyr_sowd.eq.1) then
         filename=filsowd(1:kf)//filexto(1:kexto)//extin(1:kextin)
        else
         filename=filsowd(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
        endif
        open(294,file=filename,status='old')
       endif 
       
       if (icvar_rd.eq.1) then      
        call charlen(filcropvar,kf)
        if (icyr_cropvar.eq.0) then
         filename=filcropvar(1:kf)
        elseif (icyr_cropvar.eq.1) then
         filename=filcropvar(1:kf)//filexto(1:kexto)//extin(1:kextin)
        else
         filename=filcropvar(1:kf)//filextlu(1:kextlu)//extin(1:kextin)
        endif
        open(295,file=filename,status='old')
       endif              
      endif           
            
      if (imig.eq.1) then
       call charlen(filmig,kf)
       if (icyr_mig.eq.0) then
        filename = filmig(1:kf)
       else
        filename = filmig(1:kf)//filexti(1:kexti)//extin(1:kextin)
       endif
       open(95,file=filename,status='old')
          
       call charlen(filref,kf)
       if (icyr_ref.eq.0) then
        filename = filref(1:kf)
       else
        filename = filref(1:kf)//filexti(1:kexti)//extin(1:kextin)
       endif
       open(96,file=filename,status='old')
      endif
      
      if (igtyp.eq.1) then
        call charlen(filpixcorners,kf)
        filename = filpixcorners(1:kf)
        open(97,file=filename,status='old')
      endif

c unit=5 input5 file
c unit=6 standard output

c unit=11 weather generator precipitation
c unit=12 weather generator temperature
c unit=13 BAG parameter for IBM
c unit=14 BAG climatic tolerances for CARAIB
c unit=15 BAG parameter for CARAIB
c unit=16 BAG C/N
c unit=17 BAG gkfall
c unit=18 BAG gama
c unit=19 BAG initial carbon values

      if (nyear.eq.1) then 
       if (ifrac_rd.ge.1)open(20,file=filveg_in,status='old')
       if (ilai_rd.ge.1)open(21,file=fillai_in,status='old')
c       open(22,file=filzon)
      endif
      
      call charlen(filzon,kf)
      if (iprt_zon.eq.0) then
       filename = filzon(1:kf)
      else
       filename = filzon(1:kf)//filexti(1:kexti)//extin(1:kextin)
      endif
      open(22,file=filename)

c unit=23 stochastic fields
      open(23,file=filgen,form='unformatted') 
c unit=24 water.res : daily results if ifull.eq.1

      if (nyear.eq.1) then
       if (iread.ge.1) then 
        open(25,file=filini,form='unformatted')

        call charlen(filelailimi,kf)
        filename = filelailimi(1:kf)
        open(125,file=filename,form='unformatted')
        if(ncrop.gt.0) then
	  call charlen(filecropini,kf)
          filename = filecropini(1:kf)	
          open(525,file=filename,form='unformatted')
	endif		
	open(225,file=filetemprev)
        open(325,file=fileco2prev)
       endif
       if ((ifrac_rd.ge.1).and.(icyr_landuse.ne.0)) then
        if (ilu.eq.1) open(425,file=fileluprev)
       endif		
       
       open(28,file=filtes)
       open(61,file=filetest)
       
       if (imig_rd.eq.1) then
         open(176,file=fileprop_in,status='old')
         open(177,file=fileside_in,status='old')
         open(178,file=filepres_in,status='old')
       endif
      endif

c unit=29 reinitialize annual net budget


      call charlen(filinn,kf)
      filename = filinn(1:kf)//filexto(1:kexto)//extout(1:kextout)
      open(26,file=filename,form='unformatted')
c      rewind (26) 
      
      call charlen(filelailimo,kf)
      filename = filelailimo(1:kf)//filexto(1:kexto)//extout(1:kextout)
      open(126,file=filename,form='unformatted')
c      rewind (126)

      call charlen(filecropino,kf)
      filename = filecropino(1:kf)//filexto(1:kexto)//extout(1:kextout)
      open(526,file=filename,form='unformatted')
c      rewind (526)

      call charlen(filetemprevo,kf)
      filename = filetemprevo(1:kf)//filexto(1:kexto)//extout(1:kextout)
      open(226,file=filename)
c      rewind (226)

      call charlen(fileco2prevo,kf)
      filename = fileco2prevo(1:kf)//filexto(1:kexto)//extout(1:kextout)
      open(326,file=filename)
c      rewind (326) 

c     if (ifrac.eq.1) then
       if (iprt_frac.eq.1) then
        call charlen(filefrac,kf)
        filename = filefrac(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(60,file=filename)
       endif
c     endif 

      if(iprt_laimin.eq.1)then
        call charlen(filelaimin,kf)
        filename = filelaimin(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(64,file=filename)
      endif      
c      write(*,*)filename

c beginning of if statement on iyprt
      if (iyprt.ge.1) then      

      if(iprt_yr.eq.1) then
        call charlen(filyr,kf)
        filename = filyr(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(30,file=filename)
      endif
      
      if(iprt_frc.eq.1) then
        call charlen(filfrc,kf)
        filename = filfrc(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(530,file=filename)
      endif      

      if(iprt_sw.eq.1) then
        call charlen(filsw,kf)
        filename = filsw(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(31,file=filename)
      endif
      
      if(iprt_swmm.eq.1) then
        call charlen(filswmm,kf)
        filename = filswmm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(531,file=filename)
      endif      
      
      if(iprt_rtr.eq.1) then
        call charlen(filrtr,kf)
        filename = filrtr(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(532,file=filename)
      endif      

      if(iprt_pet.eq.1) then
        call charlen(filpet,kf)
        filename = filpet(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(32,file=filename)
      endif

      if(iprt_aet.eq.1) then
        call charlen(filaet,kf)
        filename = filaet(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(33,file=filename)
      endif

      if(iprt_run.eq.1) then
        call charlen(filrun,kf)
        filename = filrun(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(34,file=filename)
      endif

      if(iprt_fsn.eq.1) then
        call charlen(filfsn,kf)
        filename = filfsn(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(35,file=filename)
      endif
      
      if(iprt_snd.eq.1) then
        call charlen(filsnd,kf)
        filename = filsnd(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(535,file=filename)
      endif
      
      if(iprt_srun.eq.1) then
        call charlen(filsrun,kf)
        filename = filsrun(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(536,file=filename)
      endif            

      if(iprt_drn.eq.1) then
        call charlen(fildrn,kf)
        filename = fildrn(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(36,file=filename)
      endif

      if(iprt_sve.eq.1) then
        call charlen(filsve,kf)
        filename = filsve(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(37,file=filename)
      endif

      if(iprt_eint.eq.1) then
        call charlen(fileint,kf)
        filename = fileint(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(537,file=filename)
      endif
      
      if(iprt_etr.eq.1) then
        call charlen(filetr,kf)
        filename = filetr(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(538,file=filename)
      endif
      
      if(iprt_eso.eq.1) then
        call charlen(fileso,kf)
        filename = fileso(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(539,file=filename)
      endif            
      
      if(iprt_rbl.eq.1) then
        call charlen(filrbl,kf)
        filename = filrbl(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(38,file=filename)
      endif      
 
      if(iprt_alb.eq.1) then
        call charlen(filalb,kf)
        filename = filalb(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(39,file=filename)
      endif

      if(iprt_albsv.eq.1) then
        call charlen(filalbsv,kf)
        filename = filalbsv(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(239,file=filename)
      endif

      if(iprt_albs.eq.1) then
        call charlen(filalbs,kf)
        filename = filalbs(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(339,file=filename)
      endif

      if(iprt_albv.eq.1) then
        call charlen(filalbv,kf)
        filename = filalbv(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(439,file=filename)
      endif

      if(iprt_rn.eq.1) then
        call charlen(filrn,kf)
        filename = filrn(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(40,file=filename)
      endif

      if(iprt_grf.eq.1) then
        call charlen(filgrf,kf)
        filename = filgrf(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(41,file=filename)
      endif

      if(iprt_ts.eq.1) then
        call charlen(filts,kf)
        filename = filts(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(42,file=filename)
      endif

      if(iprt_fgs.eq.1) then
        call charlen(filfgs,kf)
        filename = filfgs(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(43,file=filename)
      endif

      if(iprt_lai.eq.1) then
        call charlen(fillai,kf)
        filename = fillai(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(44,file=filename)
      endif

      if(iprt_fird.eq.1) then
        call charlen(filfird,kf)
        filename = filfird(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(45,file=filename)
      endif

      if(iprt_xh.eq.1) then
        call charlen(filxh,kf)
        filename = filxh(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(46,file=filename)
      endif

      if(iprt_xle.eq.1) then
        call charlen(filxle,kf)
        filename = filxle(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(47,file=filename)
      endif

      if(iprt_sol.eq.1) then
        call charlen(filsol,kf)
        filename = filsol(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(48,file=filename)
      endif

      if(iprt_sf.eq.1) then
        call charlen(filsf,kf)
        filename = filsf(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(49,file=filename)
      endif

      if(iprt_sne.eq.1) then
        call charlen(filsne,kf)
        filename = filsne(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(50,file=filename)
      endif

      if(iprt_sml.eq.1) then
        call charlen(filsml,kf)
        filename = filsml(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(51,file=filename)
      endif

      if(iprt_emi.eq.1) then
        call charlen(filemi,kf)
        filename = filemi(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(52,file=filename)
      endif

      if(iprt_emins.eq.1) then
        call charlen(filemins,kf)
        filename = filemins(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(152,file=filename)
      endif

      if(iprt_z0.eq.1) then
        call charlen(filez0,kf)
        filename = filez0(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(252,file=filename)
      endif

c units 53 to 59 for other eventual ibm outputs

      if(iprt_biomm.eq.1)then
        call charlen(filebiomm,kf)
        filename = filebiomm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(55,file=filename)
      endif
      
      if(iprt_gppm.eq.1)then
        call charlen(filegppm,kf)
        filename = filegppm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(56,file=filename)
      endif
      
      if(iprt_ram.eq.1)then
        call charlen(fileram,kf)
        filename = fileram(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(556,file=filename)
      endif      

      if(iprt_nppm.eq.1)then
        call charlen(filenppm,kf)
        filename = filenppm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(57,file=filename) 
      endif

      if(iprt_nepm.eq.1)then
        call charlen(filenepm,kf)
        filename = filenepm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(58,file=filename) 
      endif
      
      if(iprt_rhm.eq.1)then
        call charlen(filerhm,kf)
        filename = filerhm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(558,file=filename)
      endif      

      if(iprt_laim.eq.1)then
        call charlen(filelaim,kf)
        filename = filelaim(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(59,file=filename)
      endif
      
      if(iprt_emifirem.eq.1)then
        call charlen(fileemifirem,kf)
        filename=fileemifirem(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(559,file=filename)
      endif 
      
      if(iprt_emiblitm.eq.1)then
        call charlen(fileemiblitm,kf)
        filename=fileemiblitm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(560,file=filename)
      endif       

      if(iprt_nbpm.eq.1)then
        call charlen(filenbpm,kf)
        filename = filenbpm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(561,file=filename)
      endif
      
       if ((imanag.eq.1).or.(ncrop.gt.0)) then
        if(iprt_harvm .eq. 1) then
         call charlen(fileharvm,kf)
         filename = fileharvm(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(562,file=filename)	
	endif        
       endif                
      
      if(iprt_faparm.eq.1)then
        call charlen(filefaparm,kf)
        filename = filefaparm(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(98,file=filename)
      endif           


      if(iprt_Rmin.eq.1)then
        call charlen(fileRmin,kf)
        filename = fileRmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(63,file=filename) 
      endif

      if(iprt_gpp.eq.1)then
        call charlen(filegpp,kf)
        filename = filegpp(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(65,file=filename)
      endif

      if(iprt_raf.eq.1)then
        call charlen(fileraf,kf)
        filename = fileraf(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(565,file=filename)
      endif 
      
      if(iprt_emifiref.eq.1)then
        call charlen(fileemifiref,kf)
        filename=fileemifiref(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(665,file=filename)
      endif                 

      if(iprt_Cveg.eq.1)then
        call charlen(fileCveg,kf)
        filename = fileCveg(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(66,file=filename)
      endif

      if(iprt_Csoil.eq.1)then
        call charlen(fileCsoil,kf)
        filename = fileCsoil(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(67,file=filename)
      endif

      if(iprt_frcC13.eq.1)then
        call charlen(filefrcC13,kf)
        filename = filefrcC13(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(68,file=filename)
      endif

      if(iprt_laimoy.eq.1)then
        call charlen(filelaimoy,kf)
        filename = filelaimoy(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(69,file=filename) 
      endif

      if(iprt_Tdmin.eq.1)then
        call charlen(fileTdmin,kf)
        filename = fileTdmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(70,file=filename)
      endif

      if(iprt_Tmmin.eq.1)then
        call charlen(fileTmmin,kf)
        filename = fileTmmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(71,file=filename)
      endif

      if(iprt_gdd.eq.1)then
        call charlen(filegdd,kf)
        filename = filegdd(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(72,file=filename)
      endif

      if (ifire.eq.1) then

       if(iprt_fire.eq.1) then
        call charlen(filepfire,kf)
        filename = filepfire(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(73,file=filename)
       endif

       if(iprt_fburn.eq.1) then
         call charlen(filefburn,kf)
         filename = filefburn(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(74,file=filename)
       endif

       if(iprt_aburn.eq.1) then
         call charlen(fileaburn,kf)
         filename = fileaburn(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(75,file=filename)
       endif
       
       if(iprt_yfnoburn.eq.1) then
        call charlen(fileyfnoburn,kf)
        filename=fileyfnoburn(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(83,file=filename)
       endif

      endif

      if(iprt_ftomin.eq.1) then
        call charlen(fileftomin,kf)
        filename = fileftomin(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(84,file=filename)
      endif

      if(iprt_ftotw.eq.1) then
        call charlen(fileftotw,kf)
        filename = fileftotw(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(85,file=filename)
      endif
       
      if(iprt_ftot.eq.1) then
        call charlen(fileftot,kf)
        filename = fileftot(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(86,file=filename)
      endif       
        
       
      if (ifrac.eq.1) then
      
       if(iprt_Fgdd5.eq.1) then
         call charlen(fileFgdd5,kf)
         filename = fileFgdd5(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(87,file=filename)
       endif

       if(iprt_FTmmin.eq.1) then
         call charlen(fileFTmmin,kf)
        filename = fileFTmmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(88,file=filename)
       endif

       if(iprt_Fwatmin.eq.1) then
         call charlen(fileFwatmin,kf)
       filename = fileFwatmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(89,file=filename)
       endif
       
      endif
      
      if (imig.eq.1) then      
       if(iprt_prop.eq.1) then
         call charlen(fileprop,kf)
         filename = fileprop(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(76,file=filename)
       endif
       
       if(iprt_side.eq.1) then
         call charlen(fileside,kf)
         filename = fileside(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(77,file=filename)
       endif
       
       if(iprt_pres.eq.1) then
         call charlen(filepres,kf)
         filename = filepres(1:kf)//filexto(1:kexto)//extout(1:kextout)
         open(78,file=filename)
       endif
      endif

      if ((imanag.eq.1).or.(ncrop.gt.0)) then 
        if(iprt_harv.eq.1)then
         call charlen(fileharvest,kf)
         filename = fileharvest(1:kf)//filexto(1:kexto)
     &           //extout(1:kextout)
         open(79,file=filename) 
        endif
      endif 

      if(ncrop.gt.0) then
       if(iprt_yield.eq.1) then
        call charlen(fileyield,kf)
        filename = fileyield(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(880,file=filename)
       endif
      endif 
             
      if(iprt_agbiom.eq.1) then
       call charlen(fileagbiom,kf)
       filename = fileagbiom(1:kf)//filexto(1:kexto)//extout(1:kextout)
       open(881,file=filename)
      endif

      if(iprt_bgbiom.eq.1) then
       call charlen(filebgbiom,kf)
       filename = filebgbiom(1:kf)//filexto(1:kexto)//extout(1:kextout)
       open(882,file=filename)
      endif      
      
      if(ncrop.gt.0) then
       if(iprt_mat.eq.1) then
        call charlen(filemat,kf)
        filename = filemat(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(883,file=filename)
       endif
      endif   

      if (ilu.eq.1) then 
        if(iprt_lucdfr.eq.1)then      
         call charlen(filelucdfr,kf)
         filename = filelucdfr(1:kf)//filexto(1:kexto)
     &           //extout(1:kextout)
         open(251,file=filename)
	endif
        if(iprt_lucflx.eq.1)then      
         call charlen(filelucflx,kf)
         filename = filelucflx(1:kf)//filexto(1:kexto)
     &           //extout(1:kextout)
         open(252,file=filename)
	endif	           
      endif

c end of if statement on iyprt
      endif

      if(iprt_nppf.eq.1)then
        call charlen(filenppf,kf)
        filename = filenppf(1:kf)//filexto(1:kexto)//extout(1:kextout)
        open(62,file=filename)
      endif
      
c      if (ifrac.eq.1) then
       
c       if(iprt_yfnoburn.eq.1) then
c        call charlen(fileyfnoburn,kf)
c        filename = 
c     &        fileyfnoburn(1:kf)//filexto(1:kexto)//extout(1:kextout)
c        open(83,file=filename)
c       endif
       
c       if(iprt_ftot.eq.1) then
c         call charlen(fileftot,kf)
c         filename = fileftot(1:kf)//filexto(1:kexto)//extout(1:kextout)
c         open(86,file=filename)
c       endif  
       
c      endif 
      
cc      if (imig.eq.1) then
      
c       if(iprt_Fgdd5.eq.1) then
c         call charlen(fileFgdd5,kf)
c         filename = fileFgdd5(1:kf)//filexto(1:kexto)//extout(1:kextout)
c         open(87,file=filename)
c       endif

c       if(iprt_FTmmin.eq.1) then
c         call charlen(fileFTmmin,kf)
c        filename = fileFTmmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
c         open(88,file=filename)
c       endif

c       if(iprt_Fwatmin.eq.1) then
c         call charlen(fileFwatmin,kf)
c       filename = fileFwatmin(1:kf)//filexto(1:kexto)//extout(1:kextout)
c         open(89,file=filename)
c       endif
       
c      endif 

c unit 80 for time elapsed

       if (idaily_in.eq.0) then

c        call charlen(filtclim,kf)
c        if (icyr_tclim.eq.0) then
c         filename = filtclim(1:kf)
c         open(81,file=filename,status='old')
c        else
c         filename = filtclim(1:kf)//filexti(1:kexti)//extin(1:kextin)
c         open(81,file=filename,status='old')
c        endif
c// BEGIN
! Mean Temperature -- former unit 81
        iunit_tclim = 81
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_tclim, iunit_tclim, icyr_tclim, filexti, kexti, extin,
     &    filtclim, 'mean temperature climatology (i)',
     &    ncname_tclim, 
     &    ncid_filtclima, ncvar_tclima )

c// END  
      
c      call charlen(filpclim,kf)
c      if (icyr_pclim.eq.0) then
c       filename = filpclim(1:kf)
c       open(82,file=filename,status='old')
c      else
c       filename = filpclim(1:kf)//filexti(1:kexti)//extin(1:kextin)
c       open(82,file=filename,status='old')
c      endif     
c// BEGIN
! Mean Precipitation -- former unit 82
        iunit_pclim = 82
        CALL CHECK_AND_OPEN_FILE(
     &    incdf_pclim, iunit_pclim, icyr_pclim, filexti, kexti, extin,
     &    filpclim, 'mean precipitation climatology (i)',
     &    ncname_pclim, 
     &    ncid_filpclima, ncvar_pclima )

      
c       if (nyear.eq.1)then
c        open(81,file=filtclim)
c        open(82,file=filpclim)
c       endif

      endif   ! endif(idaily_in)

      if ((npft.le.0).or.(npft.gt.nplant)) then 

         write(61,*) 'Number of PFTs (',npft,') ' //
     &               'not between 1 and nplant (',nplant,')'
         write(61,*) 'Change number of PFTs or increase nplant'
         write(61,*) '  in parameter.common file'
         write(61,*) 'PROGRAM STOP'
         write(*,*) 'Number of PFTs (',npft,') ' //
     &              'not between 1 and nplant (',nplant,')'
         write(*,*) 'Change number of PFTs or increase nplant'
         write(*,*) '  in parameter.common file'
         write(*,*) 'PROGRAM STOP'
         stop
      endif

      if ((n_pix.le.0).or.(n_pix.gt.ngrid)) then

         write(61,*) 'Number of grid cells (',n_pix,') ' //
     &               'not between 1 and ngrid (',ngrid,')'
         write(61,*) 'Change number of grid cells or increase ngrid' 
         write(61,*) '  in parameter.common file'
         write(61,*) 'PROGRAM STOP'
         write(*,*) 'Number of grid cells (',n_pix,') ' //
     &              'not between 1 and ngrid (',ngrid,')'
         write(*,*) 'Change number of grid cells or increase ngrid'
         write(*,*) '  in parameter.common file'
         write(*,*) 'PROGRAM STOP'
         stop
      endif

      return

      CONTAINS


      end SUBROUTINE open_file