c=======================================================================
c***********************************************************************
      subroutine open_input5(nyrmax,itmt,stept,iread)
c***********************************************************************
c=======================================================================
      IMPLICIT NONE
      
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/acclim.common'
      include './com_18/coord.common'
      include './com_18/cte.common'
      include './com_18/envi.common'
      include './com_18/files_ibm.common'
      include './com_18/files_ext.common'
      include './com_18/files_car.common'
      include './com_18/input_par.common'
      include './com_18/icyr.common'
      include './com_18/iprt.common'
      include './com_18/management.common'
      include './com_18/netcdf_name.common'
      include './com_18/netcdf_par.common'                  
      include './com_18/nspc.common'
      include './com_18/pathg.common'
      include './com_18/prev_yr.common'      
      include './com_18/solpar.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer kf
c
c-----------------------------------------------      
      integer iread,nyrmax,itmt,idummy
      real*4 stept
      character*120 sdat
      character*120 fileinput5
      character*245 filename
      character*25 sdat1    
      
      
      write(*,*) 'Enter name of control input file (unit 5):'
      read(*,'(a120)') fileinput5
      call charlen(fileinput5,kf)
      filename = fileinput5(1:kf)
      write(*,*)'Open file: ',filename
      open(5,file=filename)
      
c      open(5,file='./caraib_5.dat')

      read(5,'(20x,a120)') sdat
      read(sdat,*) isteady,ny0max 
      read(5,'(20x,a120)')sdat
      read(sdat,*) readsteady,coupling 
      read(5,'(20x,a120)')sdat
      read(sdat,*)ngener
      read(5,'(20x,a120)') sdat 
      read(sdat,*) ifrac
      read(5,'(20x,a120)')sdat
      read(sdat,*) ifrac_rd,ilai_rd
      read(5,'(20x,a120)')sdat
c  jclonly = allows printing climatic files without running the model (jclonly) 
c  jclonly = 0 performs all calculations
c  jclonly = 1 prints climatic fields, do not perform calculations     
      read(sdat,*)idayt,ifull,jclonly
      read(5,'(20x,a120)')sdat
      read(sdat,*)ilu,imanag
      read(5,'(20x,a120)')sdat
      read(sdat,*)ilusp_rd,isowd_rd 
      read(5,'(20x,a120)')sdat
      read(sdat,*)ncropvar,icvar_rd            
c  jdwnCO2 = controls downregulation at high CO2
c    jdwnCO2 = 0 no downregulation
c    jdwnCO2 = 1 downregulation of Vcmax, Jmax and Rd
c    jdwnCO2 = 2 downregulation of Vcmax, Jmax, but not Rd           
      read(5,'(20x,a120)')sdat
      read(sdat,*)ifire,iclim,ilgtree
      read(5,'(20x,a120)')sdat
      read(sdat,*)jdwnCO2,jrd_accl      
      read(5,'(20x,a120)')sdat
      read(sdat,*)imig,isp,imig_rd
c  ileap: flag to take leap year into account
c         ileap=0 no leap year (nd=365, default value)
c         ileap=1 leap year taken into account depending on the year 
c                 number defined in "myear" variable (subroutine 
c                 open_file)      
      read(5,'(20x,a120)')sdat      
      read(sdat,*)nyrmax,ileap      !,idayct
      read(5,'(20x,a120)')sdat
      read(sdat,*)itmt
      read(5,'(20x,a120)')sdat
      read(sdat,*)ny0prt,nstprt
c  iread: controls reading of initialization files
c    iread = 0 initialiszation files are not read (default init.)
c    iread = 1 reading of initialization files for all pfts (nat+agr)
c    iread = 2 reading of initialization files for natural pfts only       
      read(5,'(20x,a120)')sdat
      read(sdat,*)iread,iczon
      read(5,'(20x,a120)')sdat
      read(sdat,*)idaily_in,idaily_out
      
c     Tmin Tmax, solar flux
      read(5,'(20x,a120)')sdat
      read(sdat,*)idtem,isol
      
      if ((isol.eq.1).and.(idaily_in.eq.0)) then
        write(*,*)'Incompatible values for isol and idaily_in:'
	write(*,*)'with monthly input fields, relative sunshine hours'
	write(*,*)'should be provided rather than solar fluxes'
	write(*,*)'Program stop'
	stop
      endif
      
      read(5,'(20x,a120)')sdat
      read(sdat,*)n_pix
      read(5,'(20x,a120)')sdat
      read(sdat,*)igtyp 
      if (igtyp.eq.0) read(sdat,*)idummy,declg,declat
      read(5,'(20x,a120)')sdat
      read(sdat,*)prec_co 
      write(*,*)'igtyp:',igtyp,declg,declat,prec_co     
     
      read(5,'(20x,a120)')sdat
      read(sdat,*)ipar,exc,obl,xlsper
 
      read(5,'(20x,a120)') sdat
      read(sdat,*) nherb,nbush,ntree,ncrop,npast
      
      if (ilu.ne.1) then
        if ((ncrop.ne.0).or.(npast.ne.0)) then
	  write(*,*)'Inconsistent values of ilu and ncrop, npast: '
	  write(*,*)'when land use is not considered (ilu.ne.1),'
	  write(*,*)'the number of crop (ncrop) and pasture (npast) ' 
	  write(*,*)'species/pfts must be set to 0'
	  write(*,*)'ilu= ',ilu
	  write(*,*)'ncrop= ',ncrop,'  npast= ',npast
	  write(*,*)'Program stop'
	  stop
	endif
      else
        if ((ncrop.eq.0).and.(npast.eq.0)) then
	  write(*,*)'Inconsistent values of ilu and ncrop, npast: '
	  write(*,*)'when land use is considered (ilu.eq.1), at least '
	  write(*,*)'one crop (ncrop>=1) or one pasture (npast>=1) ' 
	  write(*,*)'species/pfts must be defined'
	  write(*,*)'ilu= ',ilu
	  write(*,*)'ncrop= ',ncrop,'  npast= ',npast
	  write(*,*)'Program stop'
	  stop
	endif        
      endif
      
      npft0 = nherb+nbush+ntree
      npft  = npft0+ncrop+npast
      if(npft.gt.nplant) then
        write(*,*) 'error, number of pft:',npft,'nherb:',nherb,
     &              'nbush:',nbush,'ntree:',ntree,'ncrop:',ncrop,
     &              'npast:',npast      
        write(61,*) 'error, number of pft:',npft,'nherb:',nherb,
     &              'nbush:',nbush,'ntree:',ntree,'ncrop:',ncrop,
     &              'npast:',npast
        write(*,*)'Increase the value of nplant in parameter.common' 
	write(*,*)'file or decrease the number of pfts'
        stop
      endif
      
      read(5,'(20x,a120)')extin 
      call charlen(extin,kextin)
      read(5,'(20x,a120)')extout
      call charlen(extout,kextout)
      write(*,*)'in:',extin
      write(*,*)'out:',extout
      
      read(5,'(20x,a120)')filtxt      
      read(5,'(20x,a120)')filpixcorners
      read(5,'(20x,a120)')filclim
      
      
c  Air temperature (climatological)      
      read(5,'(20x,i1,1x,a120)')icyr_tclim,filtclim
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_tclim
      read(sdat1,*)uc0_tclim,uc1_tclim,incdf_tclim

c  Precipitation (climatological)      
      read(5,'(20x,i1,1x,a120)')icyr_pclim,filpclim      
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_pclim    
      read(sdat1,*)uc0_pclim,uc1_pclim,incdf_pclim
                  
c  Air temperature      
      read(5,'(20x,i1,1x,a120)')icyr_tem,filtem
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_tem
      read(sdat1,*)uc0_tem,uc1_tem,incdf_tem
      
c  Tmax     
      read(5,'(20x,i1,1x,a120)')icyr_dta,fildta
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_dta
      read(sdat1,*)uc0_dta,uc1_dta,incdf_dta 
      
c  Tmin    
      read(5,'(20x,i1,1x,a120)')icyr_dtb,fildtb
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_dtb
      read(sdat1,*)uc0_dtb,uc1_dtb,incdf_dtb 
      
c  Precipitation     
      read(5,'(20x,i1,1x,a120)')icyr_prc,filprc
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_prc
      read(sdat1,*)uc0_prc,uc1_prc,incdf_prc                

c  Relative sunshine hours (isol = 0) or solar flux (isol = 1)      
      read(5,'(20x,i1,1x,a120)')icyr_shi,filshi
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_shi
      read(sdat1,*)uc0_shi,uc1_shi,incdf_shi

c  Relative air humidity       
      read(5,'(20x,i1,1x,a120)')icyr_rhu,filrhu
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_rhu
      read(sdat1,*)uc0_rhu,uc1_rhu,incdf_rhu

c  Wind speed      
      read(5,'(20x,i1,1x,a120)')icyr_win,filwin
      read(5,'(20x,a25,1x,a10)')sdat1,ncname_win
      read(sdat1,*)uc0_win,uc1_win,incdf_win

c  Other files      
      read(5,'(20x,i1,1x,a120)')icyr_manag,filemanag      
      read(5,'(20x,i1,1x,a120)')icyr_light,fillight
      read(5,'(20x,i1,1x,a120)')icyr_landuse,fillanduse
      read(5,'(20x,i1,1x,a120)')icyr_lusp,fillusp
      read(5,'(20x,i1,1x,a120)')icyr_sowd,filsowd
      read(5,'(20x,i1,1x,a120)')icyr_cropvar,filcropvar                  
      read(5,'(20x,i1,1x,a120)')icyr_mig,filmig
      read(5,'(20x,i1,1x,a120)')icyr_ref,filref
      
      num_ncdf = incdf_tem + incdf_dta + incdf_prc + incdf_shi
     &         + incdf_rhu + incdf_win
      if (idtem.eq.1) num_ncdf = num_ncdf + incdf_dtb

c     print out file names for verif
      write(*,*),'Texture file:                    ',filtxt
      write(*,*),'Temperature file (climatology):  ',filtclim
      write(*,*),'Precipitation file (climatology):',filpclim
      write(*,*),'Temperature file:                ',filtem
      write(*,*),'Temp max file:                   ',fildta
      write(*,*),'Temp min file:                   ',fildtb
      write(*,*),'Precipitation file:              ',filprc
      write(*,*),'Shunshine file:                  ',filshi
      write(*,*),'Rel humidity file:               ',filrhu
      write(*,*),'Wind speed file:                 ',filwin
      write(*,*),'Lightning file:                  ',fillight

      read(5,'(20x,a120)')pathgene
      write(*,*),'pathgene:                  '

      read(5,'(20x,a120)')filbagibm
      read(5,'(20x,a120)')filebagtol
      read(5,'(20x,a120)')filebagpar
      read(5,'(20x,a120)')fileclaspar
      read(5,'(20x,a120)')filecsurn
      read(5,'(20x,a120)')filegkf
      read(5,'(20x,a120)')filegama
      read(5,'(20x,a120)')filecinit 
      read(5,'(20x,a120)')fileseas
      write(*,*),'plantparam read:                  '

      
      read(5,'(20x,i1,1x,a120)')iprt_tem,filotem
      read(5,'(20x,i1,1x,a120)')iprt_dte,filodte
      read(5,'(20x,i1,1x,a120)')iprt_prc,filoprc
      read(5,'(20x,i1,1x,a120)')iprt_shr,filoshr
      read(5,'(20x,i1,1x,a120)')iprt_rhu,filorhu
      read(5,'(20x,i1,1x,a120)')iprt_win,filowin 
      write(*,*),'print clim:                  '

             
c initialization files
      read(5,'(20x,a120)')filveg_in
      read(5,'(20x,a120)')fillai_in
      read(5,'(20x,a120)')filini
      read(5,'(20x,a120)')filelailimi
      read(5,'(20x,a120)')filecropini      
      read(5,'(20x,a120)')fileco2prev 
      read(5,'(20x,a120)')filetemprev
      read(5,'(20x,a120)')fileluprev            
      write(*,*),'ini files 1:                  ',fileluprev

      
      read(5,'(20x,a120)')fileprop_in
      read(5,'(20x,a120)')fileside_in
      read(5,'(20x,a120)')filepres_in  
      read(5,'(20x,i1,1x,a120)')iprt_zon,filzon
      read(5,'(20x,a120)')filgen      
      write(*,*),'ini files 2:                  ',filgen

      
      read(5,'(20x,a120)')filres
      read(5,'(20x,a120)')filinn
      read(5,'(20x,a120)')filelailimo
      read(5,'(20x,a120)')filecropino      
      read(5,'(20x,a120)')fileco2prevo
      read(5,'(20x,a120)')filetemprevo            
      read(5,'(20x,a120)')filtes
      read(5,'(20x,a120)')filetest
      read(5,'(20x,a120)')filtim   
      write(*,*),'ini files 3:                  ',filtim


      read(5,'(20x,i1,1x,a120)') iprt_yr,filyr
      read(5,'(20x,i1,1x,a120)') iprt_frc,filfrc      
      read(5,'(20x,i1,1x,a120)') iprt_sw,filsw
      read(5,'(20x,i1,1x,a120)') iprt_swmm,filswmm
      read(5,'(20x,i1,1x,a120)') iprt_rtr,filrtr      
      read(5,'(20x,i1,1x,a120)') iprt_pet,filpet
      read(5,'(20x,i1,1x,a120)') iprt_aet,filaet
      read(5,'(20x,i1,1x,a120)') iprt_run,filrun
      read(5,'(20x,i1,1x,a120)') iprt_fsn,filfsn
      read(5,'(20x,i1,1x,a120)') iprt_snd,filsnd
      read(5,'(20x,i1,1x,a120)') iprt_srun,filsrun      
      read(5,'(20x,i1,1x,a120)') iprt_drn,fildrn
      read(5,'(20x,i1,1x,a120)') iprt_sve,filsve
      read(5,'(20x,i1,1x,a120)') iprt_eint,fileint
      read(5,'(20x,i1,1x,a120)') iprt_etr,filetr
      read(5,'(20x,i1,1x,a120)') iprt_eso,fileso                  
      write(*,*),'output 1:                  ',fileso

      
c following ibm outputs are optional
      read(5,'(20x,i1,1x,a120)') iprt_rbl,filrbl
      read(5,'(20x,i1,1x,a120)') iprt_alb,filalb
      read(5,'(20x,i1,1x,a120)') iprt_albsv,filalbsv
      read(5,'(20x,i1,1x,a120)') iprt_albs,filalbs
      read(5,'(20x,i1,1x,a120)') iprt_albv,filalbv
      read(5,'(20x,i1,1x,a120)') iprt_rn,filrn
      read(5,'(20x,i1,1x,a120)') iprt_grf,filgrf
      read(5,'(20x,i1,1x,a120)') iprt_ts,filts
      read(5,'(20x,i1,1x,a120)') iprt_fgs,filfgs
      read(5,'(20x,i1,1x,a120)') iprt_lai,fillai
      read(5,'(20x,i1,1x,a120)') iprt_fird,filfird
      read(5,'(20x,i1,1x,a120)') iprt_xh,filxh
      read(5,'(20x,i1,1x,a120)') iprt_xle,filxle
      read(5,'(20x,i1,1x,a120)') iprt_sol,filsol
      read(5,'(20x,i1,1x,a120)') iprt_sf,filsf
      read(5,'(20x,i1,1x,a120)') iprt_sne,filsne
      read(5,'(20x,i1,1x,a120)') iprt_sml,filsml
      read(5,'(20x,i1,1x,a120)') iprt_emi,filemi
      read(5,'(20x,i1,1x,a120)') iprt_emins,filemins
      read(5,'(20x,i1,1x,a120)') iprt_z0,filez0
      write(*,*),'hydro files:                  ',filez0


      read(5,'(20x,i1,1x,a120)') iprt_biomm,filebiomm
      read(5,'(20x,i1,1x,a120)') iprt_gppm,filegppm
      read(5,'(20x,i1,1x,a120)') iprt_ram,fileram      
      read(5,'(20x,i1,1x,a120)') iprt_nppm,filenppm
      read(5,'(20x,i1,1x,a120)') iprt_nepm,filenepm
      read(5,'(20x,i1,1x,a120)') iprt_rhm,filerhm      
      read(5,'(20x,i1,1x,a120)') iprt_laim,filelaim
      read(5,'(20x,i1,1x,a120)') iprt_emifirem,fileemifirem
      read(5,'(20x,i1,1x,a120)') iprt_emiblitm,fileemiblitm      
      read(5,'(20x,i1,1x,a120)') iprt_nbpm,filenbpm 
      read(5,'(20x,i1,1x,a120)') iprt_harvm,fileharvm                 
      read(5,'(20x,i1,1x,a120)') iprt_faparm,filefaparm

      read(5,'(20x,i1,1x,a120)') iprt_frac,filefrac
      read(5,'(20x,i1,1x,a120)') iprt_nppf,filenppf
      read(5,'(20x,i1,1x,a120)') iprt_Rmin,fileRmin
      read(5,'(20x,i1,1x,a120)') iprt_laimin,filelaimin
      read(5,'(20x,i1,1x,a120)') iprt_gpp,filegpp
      read(5,'(20x,i1,1x,a120)') iprt_raf,fileraf
      read(5,'(20x,i1,1x,a120)') iprt_emifiref,fileemifiref                  
      read(5,'(20x,i1,1x,a120)') iprt_Cveg,fileCveg
      read(5,'(20x,i1,1x,a120)') iprt_Csoil,fileCsoil
      read(5,'(20x,i1,1x,a120)') iprt_frcC13,filefrcC13
      read(5,'(20x,i1,1x,a120)') iprt_laimoy,filelaimoy
      read(5,'(20x,i1,1x,a120)') iprt_Tdmin,fileTdmin
      read(5,'(20x,i1,1x,a120)') iprt_Tmmin,fileTmmin
      read(5,'(20x,i1,1x,a120)') iprt_gdd,filegdd
      read(5,'(20x,i1,1x,a120)') iprt_fire,filepfire
      read(5,'(20x,i1,1x,a120)') iprt_fburn,filefburn
      read(5,'(20x,i1,1x,a120)') iprt_aburn,fileaburn 
      read(5,'(20x,i1,1x,a120)') iprt_harv,fileharvest
      read(5,'(20x,i1,1x,a120)') iprt_yield,fileyield
      read(5,'(20x,i1,1x,a120)') iprt_agbiom,fileagbiom
      read(5,'(20x,i1,1x,a120)') iprt_bgbiom,filebgbiom      
      read(5,'(20x,i1,1x,a120)') iprt_mat,filemat         
      read(5,'(20x,i1,1x,a120)') iprt_lucdfr,filelucdfr      
      read(5,'(20x,i1,1x,a120)') iprt_lucflx,filelucflx      
     
      read(5,'(20x,i1,1x,a120)') iprt_yfnoburn,fileyfnoburn
      read(5,'(20x,i1,1x,a120)') iprt_ftomin,fileftomin
      read(5,'(20x,i1,1x,a120)') iprt_ftotw,fileftotw
      read(5,'(20x,i1,1x,a120)') iprt_ftot,fileftot
      read(5,'(20x,i1,1x,a120)') iprt_Fgdd5,fileFgdd5
      read(5,'(20x,i1,1x,a120)') iprt_FTmmin,fileFTmmin
      read(5,'(20x,i1,1x,a120)') iprt_Fwatmin,fileFwatmin
      read(5,'(20x,i1,1x,a120)') iprt_prop,fileprop
      read(5,'(20x,i1,1x,a120)') iprt_side,fileside
      read(5,'(20x,i1,1x,a120)') iprt_pres,filepres
      write(*,*),'outputs end:                  ',filepres


c reads comment line

      read(5,'(a120)') sdat
      write(*,*) sdat
      write(*,*) 'End of CTRL file reading'

      return
      end subroutine open_input5