c=======================================================================
c***********************************************************************
      subroutine read_eco(ngt)
c***********************************************************************
c=======================================================================

c=======================================================================
c     This routine reads the different environmental inputs as well
c     as vegetation characteristics and set them in the right form.
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/climin0.common'
      include './com_18/climkop.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/eco.common'
      include './com_18/ecoin.common'
      include './com_18/ecopro.common'
      include './com_18/envi.common'
      include './com_18/estab.common'
      include './com_18/gridclim.common'
      include './com_18/griddata.common'
      include './com_18/gridin2.common'
      include './com_18/input_par.common'
      include './com_18/inidata.common'
      include './com_18/landuse.common'      
      include './com_18/nspc.common'
      include './com_18/smrd.common'
      include './com_18/sr_par.common'
      include './com_18/temper.common'
      include './com_18/vegfr.common'
      include './com_18/xlaic.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer igrr,ngt
      real*4  elv
c
c-----------------------------------------------
c=======================================================================
c   reads soil characteristic and elevation
c   igrr: pixel number
c   xlg, xlt: longitude, latitude (degrees)
c   isu: soil unit (FAO, Zobler classification)
c   clay, silt, sand: clay, silt, sand contents of soils (%)
c   elev: land elevation (m)
c   xcolor: soil color (0=dark, 0.5=medium, 1=clear)
c=======================================================================
      read(1,*)igrr,ylongi,ylati,isunit,cla,sil,san,elv,colour
      if(elv.lt.0.)elv=0.

      xlg(ngt) = ylongi
      xlt(ngt) = ylati
      isu(ngt) = isunit
      sand(ngt) = san
      silt(ngt) = sil
      clay(ngt) = cla
      elev(ngt) = elv
      xcolor(ngt) = colour
      
      
      return
      end subroutine read_eco