c=======================================================================
c***********************************************************************
      subroutine veg_phases(ngt)
c***********************************************************************
c=======================================================================

c=======================================================================
c     This routine determines crop growing phases
c=======================================================================
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/burned.common'
      include './com_18/climin0.common'
      include './com_18/climin.common'
      include './com_18/coord.common'
      include './com_18/cte.common'
      include './com_18/crops.common'
      include './com_18/eco.common'      
      include './com_18/gddpix.common'
      include './com_18/gene.common'
      include './com_18/inidata.common'
      include './com_18/init.common'            
      include './com_18/iprt.common'
      include './com_18/monthcst.common'
      include './com_18/nspc.common'
      include './com_18/plant_pool.common'      
      include './com_18/prt_ctrl.common'
      include './com_18/pzone.common'
      include './com_18/snow.common'
      include './com_18/temper.common' 
      include './com_18/tresh.common'
            
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer iday,iday1,iday2,ip,ngt
c
c-----------------------------------------------
       
      integer iday_sow,lim,gr_length,i,ivar,igerm,isow
      real*4 aaa,bbb,gdd_seas,wat_germ
      
c=======================================================================
c     read crop cultivars
c=======================================================================  
      
      if (icvar_rd.eq.1) then
       do i = 1, npft
        icvar(i) = 0
       end do
       read(295,*)aaa,bbb,(icvar(i),i=npft0+1,npft0+ncrop)      
      endif    

c=======================================================================
c     growing phases for crops:
c        0  = dormancy
c        1  = growing season
c        2  = harvesting
c=======================================================================
c specific for natural vegetation
c
c      do ip = 1, npft0
c	do iday = 1, nd
c	  iday2=iday-1
c	  iphase(ip,iday) = 1
c	  if(iday.eq.1) then
c	    iday2 = nd	    
c	    iphase(ip,iday2) = 1
c          endif  	  
c        enddo      
c      enddo      

cc specific for crops and pastures      
      do ip = 1, npft
cc      do ip = npft0+1, npft

c	iday_sow = int(sow_date(ip))        
c	if (iday_sow.ge. 0) then


cc Correction for crops only
	if ((ip .ge.(npft0+1)) .and. (ip .le. (npft0+ncrop))) then
c        ivar = icvar(ip)
        maturity(ip) = -999
	wat_germ = wattresh2(ip) + 0.1*wattresh2(ip)
	gdd_seas = gdd_ini(ip,ngt)
	iday_sow = int(sow_date(ip))  


	isow = 0
	igerm = 0
	if(gdd_ini(ip,ngt).gt.0.) isow = 1
	do iday = 1, nd
	  iday2=iday-1
	  iphase(ip,iday) = 1
	  if(iday.eq.1) then
	    iday2 = nd	    
	    if(carbon(ip,2,iday2).gt.0.) igerm = 1
	    iphase(ip,iday2) = 1
          endif  	  
          if(iday.eq.iday_sow) then
	    isow = 1
	    gdd_seas = 0.
	    iday_germ(ip,ngt) = -999
	    igerm = 0
	  endif  	
	  if(isow.eq.1) then	    
            if(tcel(iday).gt.tbase(ip)) then
              gdd_seas = gdd_seas + (tcel(iday) - tbase(ip))
	    endif
            if(gdd_seas .lt. gdd_germ(ip)) iphase(ip,iday) = 0	    
	    if(igerm.eq.0.and.gdd_seas.ge.gdd_germ(ip)) then
	      if(water(iday).lt.wat_germ) then
	        iphase(ip,iday) = 0
	      else
	        igerm = 1
	        iday_germ(ip,ngt) = iday
	        gdd_seas = gdd_germ(ip) 
	      endif
	    endif	  
	    if(iday_germ(ip,ngt).gt.iday) then
c	      gr_length = nd - iday_germ(ip,ngt) + iday
	      gr_length = nd - iday_sow + iday
	    else
c	      gr_length = iday - iday_germ(ip,ngt)
              gr_length = iday - iday_sow
	      if(iday_germ(ip,ngt).le.0) gr_length = 0
	    endif
	    if(gr_length.gt.gr_seas(ip)) then
	      iphase(ip,iday) = 0
	      gdd_seas = 0.
	      isow = 0
	      igerm = 0
	    endif 
	      	  
            if(gdd_seas .gt. gdd_harv(ip) .and. 
     &	        gr_length .le. gr_seas(ip) .and. igerm .eq. 1) then
              iphase(ip,iday) = 2
	      gdd_seas = 0.
	      isow = 0
	      igerm = 0	    
            endif
	    if(iphase(ip,iday2).eq.1.and.iphase(ip,iday).eq.2) then
	      maturity(ip)=iday
	    endif	  
	  else
	    iphase(ip,iday) = 0
	    gdd_seas = 0.
	    iday_germ(ip,ngt) = -999	    
	  endif	  
          if(iday.eq.nd) then	 
    	    gdd_ini(ip,ngt) = gdd_seas
	  endif		       	      	    
        enddo
	
      else
	do iday = 1, nd
	  iday2=iday-1
	  iphase(ip,iday) = 1
	  if(iday.eq.1) then
	    iday2 = nd	    
	    iphase(ip,iday2) = 1
          endif  	  
        enddo      
      
      endif      	
      enddo
      
      return
      end subroutine veg_phases