
subroutine inigen
    ! +------------------------------------------------------------------------+
    ! | MAR INPUT                                               5-10-2020  MAR |
    ! |   subroutine inigen set .true. MAR Initialization Procedure                |
    ! |                                                                        |
    ! +------------------------------------------------------------------------+

    ! +--Global Variables
    ! +  ================
    use marctr
    use marphy
    use mardim
    use margrd
    use mar_ge
    use marsnd
    use mar_dy
    use mar_lb
    use mar_ub
    use marsib
    use mar_te
    use mar_tu
    use mar_fi
    use mar_ra
    use mar_hy
    use mar_ca
    use mar_pb
    use mar_io
    use marssn
    use mar_sl

    use mar_sv

    implicit none

    ! +--Local Variables and DATA
    ! +  ========================
    integer i, j, k, m
    external zext
    integer zext
    logical zoro
    logical verti0
    integer itever, itexpe2

    integer iyrCVA, mmaCVA, jdaCVA, jhuCVA
    integer iyrHYD, mmaHYD, jdaHYD, jhuHYD

    integer iyrTUR, mmaTUR, jdaTUR, jhuTUR
    integer iyrSOL, mmaSOL, jdaSOL, jhuSOL

    integer imezdy, jmezdy, mzabs1, itizon
    integer lo_CAU, ipri, iv_ini, n, isl

    ! +--Modified Time Step
    ! +  ~~~~~~~~~~~~~~~~~~
    integer YYtmp, MMtmp, DDtmp
    real dtdom, zmin_0, aavu_0, bbvu_0, ccvu_0, ps_sig

    real aladyn, alodyn, gradTz, rhcrit, tstart
    real sh2(mx, my), sh3(mx, my, mw - 1)
    character * 3 swich(0:1)
    data swich/'OFF', 'ON '/
    data ps_sig/100./

    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! +++ INITIALISATION of the DOMAIN characterISTICS +++++++++++++++++++++++++
    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    open(unit=1, status='old', file='MARdom.dat')
    rewind 1
    read(1, 141) explIO
141 format(a3)
    read(1, 145) GElat0, GElon0, GEddxx
    read(1, 1425) mma0GE, jda0GE, jhu0GE, itizon, iyr0GE
1425 format(4i4, i4)
    read(1, 1426) imez, jmez, maptyp, GEtrue
1426 format(3i4, 28x, e13.6)
    read(1, 1427) igrdIO
1427 format(5i4)
    read(1, 1427) jgrdIO
    read(1, 1427) IO_gen
    IO_loc = IO_gen
    read(1, 1427) mxw1IO, mxw2IO, ixw_IO
    read(1, 1427) myw1IO, myw2IO, iyw_IO
    read(1, 1427) mzw1IO, mzw2IO, izw_IO
    ! kkatIO, kmidIO : For output on NetCDF Files:
    !                  Assumed Levels of Bound.Layer / Mid Troposph.
    read(1, 1427) kkatIO, kmidIO
    read(1, 145) dx, dy, dtdom
145 format(4d13.6)
    read(1, 1450) verti0
1450 format(l3)
    ! ptopDY: model top pressure
    read(1, 145) ptopDY
    read(1, 145) zmin_0, aavu_0, bbvu_0, ccvu_0
    z__SBL = zmin_0
    read(1, 145) FIslot, FIslou, FIslop, FIkhmn
    read(1, 145) TUkhff, TUkhmx
    TUkhmx = TUkhmx * dtdom / dt
    read(1, 145) tequil, dtquil
    read(1, 145) zs_SL, zn_SL, zl_SL, cs2SL
    read(1, 145) sst_SL
    read(1, 145) dtagSL
    read(1, 145) w20SL, wg0SL, wk0SL, wx0SL
    read(1, 1430)
1430 format(1x)
    read(1, 143) isolSL
143 format((10i13))
    read(1, 1430)
    read(1, 1432) sh2
    if(itexpe <= 1) then
        sh = sh2
    endif
1432 format((10d13.6))
    read(1, 1430)
    read(1, 1432) SL_z0
    read(1, 1430)
    read(1, 1432) SL_r0
    read(1, 1430)
    read(1, 1432) ch0SL
    read(1, 1430)
    read(1, 1432) rsurSL
    read(1, 1430)

    ! +--Underlaying Surface Albedo (to which Surface alb0SL is set,
    ! +  ~~~~~~~~~~~~~~~~~~~~~~~~~~  unless NOT 1st Run, itexpe /= 0)
    read(1, 1432) albsSL
    alb0SL = albsSL
    read(1, 1430)
    read(1, 1432) eps0SL
    read(1, 1430)
    read(1, 1432) d1_SL

    if(geoNST) then
        read(1, 1430)
        read(1, 1432)((GElonh(i, j), i=1, mx), j=1, my)
        read(1, 1430)
        read(1, 1432)((GElatr(i, j), i=1, mx), j=1, my)
        read(1, 1430)
        read(1, 1432) sigma

        ! degrees --> radians
        GElatr = GElatr * degrad
        ! degrees --> hours
        GElonh = GElonh / 15.

        do k = 1, mz
            zsigma(k) = -(sst_SL / 0.0065) * ((1.e0 + (sigma(k) - 1.) &
                                               * (1.e2 / ps_sig))**(RDryAi * 0.0065 / gravit) - 1.)
        enddo

        if(IO_gen >= 2) then
            write(21, 130)(sigma(k), k=1, mz)
130         format(/, '  Sigma    Levels :', /,(1x, 15f8.4))
            write(21, 131)(zsigma(k), k=1, mz)
131         format(/, '  Altitude Levels :', /,(1x, 15f8.1))
        endif
    endif

    close(unit=1)

    ! + ***   *CL* Read subgrid topography   ***
    if(mw == 5) then
        open(unit=555, status='old', file='MARdom2.dat')
        print *, '***************************'
        print *, '*   Read of MARdom2.dat   *'
        print *, '***************************'
        read(555, '(f12.6)') sh3
        if(itexpe <= 1) then
            do i = 1, mx
                do j = 1, my
                    do k = 1, nsx - 1
                        sh_int(i, j, k) = sh3(i, j, k)
                    enddo
                    sh_int(i, j, nsx) = sh(i, j)
                enddo
            enddo
        endif
        close(unit=555)
    endif

    ! +--SVAT IO
    ! +  -------
    if(vegmod .and. .not. reaVAR) then
        ! +  ******
        call svasav('read')
        ! +  ******
    endif

    ! +--Time Discretisation
    ! +  ===================

    ! +--Slow Dynamics
    ! +  -------------
    idt = dt
    jdt = (dt - idt) * 100.

    ! +--Fast Dynamics
    ! +  -------------
    dtfast = dt / (ntFast + 1)

    ! +--Subgrids
    ! +  --------
    if(dtDiff < dt) then
        if(dtDiff > 0.) then
            ! ntDiff : Number of Subgrid Scale Steps for 1 Dynamical Step
            ntDiff = dt / dtDiff
            ! dtDiff : Calibrated Subgrid Scale Time Step
            dtDiff = dt / ntDiff
            jtDiff = 1
        else
            ntDiff = 1
            jtDiff = nboucl * nprint + 1
        endif
    else
        ! jtDiff : Number of Dynamical Steps for 1 Subgrid Scale Step
        jtDiff = dtDiff / dt
        jtDiff = max(jtDiff, 1)
        ! dtDiff : Calibrated Subgrid Scale Time Step
        dtDiff = dt * jtDiff
        ntDiff = 1
    endif
    if(dtDiff > 0.) then
        !XF
        ntDiff = 1
        dtDiff = dt
        jtDiff = 1
        !XF
    endif

    ! +--Surface   Physics
    ! +  -----------------
    if(dtPhys < dt) then
        ! ntPhys : Number of Surface Phys. Steps for 1 Dynamical Step
        ntPhys = dt / dtPhys
        ! dtPhys :  Calibrated Surface Phys. Time Step
        dtPhys = dt / ntPhys
        jtPhys = 1
    else
        ! jtPhys : Number of Dynamical Steps for 1 Surface Phys. Step
        jtPhys = dtPhys / dt
        jtPhys = max(jtPhys, 1)
        ! dtPhys : Calibrated Surface Physics Time Step
        dtPhys = dt * jtPhys
        ntPhys = 1
    endif

    !XF
    ntPhys = 1
    dtPhys = dt
    jtPhys = 1
    !XF

    ! +--Radiation Physics
    ! +  -----------------
    if(dtRadi < dt) then
        write(6, *) ' NO Split Time Differ.  on dtRadi  !!#�@|#@&##!!     EMERGENCY EXIT '
        STOP
        ! ntRadi : Number of Surface Phys. Steps for 1 Dynamical Step
        ntRadi = dt / dtRadi
        ! dtRadi : Calibrated Surface Phys. Time Step
        dtRadi = dt / ntRadi
        jtRadi2 = 1
    else
        ! jtRadi : Number of Dynamical Steps for 1 Surface Phys. Step
        jtRadi2 = dtRadi / dt
        ! dtRadi : Calibrated Surface Physics Time Step
        dtRadi = dt * jtRadi2
        ntRadi = 1
    endif

    ! +--Other Constants
    ! +  ---------------

    t2SLtn = 1.0 / dtPhys - 0.50 / cs2SL
    t2SLtd = 1.0 / dtPhys + 0.50 / cs2SL
    ! fracSL : Fractional Time (Blowing Snow Srf Flux Computation)
    !          Factor   1.8d3 is the Turbulence Time Scale (1/2 h)
    !          Factor   0.6d3 is used.
    fracSL = dt / 0.6e3
    fracSL = min(unun, fracSL)

    ! +--Coriolis Parameter
    ! +  ==================
    ! fcorDY : Coriolis Parameter (Indicative Value)
    fcorDY(imez, jmez) = 2.0 * earthv * sin(GElat0 * degrad)

    ! +--OUTPUT
    ! +  ======
    if(IO_loc >= 1) then
        write(21, 600) explIO, GElat0, GElon0, &
            jda0GE, mma0GE, jhu0GE, itizon, &
            minuGE, jsecGE, fcorDY(imez, jmez), cz0_GE
600     format(/, ' SIMULATION ', a3, /, ' ++++++++++++++', //, &
                ' Lat.', f5.1, 3x, 'Long.', f6.1, 4x, 'Date :', i3, '-', i2, &
                ' / ', i2, ' h.UT +(', i3, ')LT', i3, ' min.', i3, ' sec.', &
                //, ' f(Coriolis) = ', e12.5, &
                /, ' cos(Z) min  : ', e12.5)
        write(21, *) ' CODE STATUS  +++++++++++'

        write(21, *) '#VN DYNAMICS: Variable Number of Leap-Frog Loops (Fast Waves)'

        write(21, *) '#DA DYNAMICS: Lateral BC: Davies (1976) BC on Wind // Lat.B. '

        write(21, *) '#RF DYNAMICS: Top BC: Rayleight Friction in the Top Sponge   '

        write(21, *) '#CA CONVECTIVE  Adjustment (general                 Set Up)  '

        write(21, *) '#ca CONVECTIVE  Adjustment (no Vector               Set Up)NV'

        write(21, *) '#PB CONVECTIVE  Adjustment (Peter Bechtold     2000 Set Up)  '
        write(21, *) '#pb CONVECTIVE  Adjustment (Peter Bechtold     2000 Set Up)NV'

        write(21, *) '#TA TURBULENCE: K-e: Dissipation + Advect.Horiz.TKE Transport'
        write(21, *) '#TD TURBULENCE: K-e: Dissipation + Diffus.Horiz.TKE Transport'

        write(21, *) '#KA TURBULENCE: T.K.E. & e(T.K.E.) Filter along the vertical '

        write(21, *) '#SY TURBULENCE: Sea Spray Parameterization (Andreas, 199x) ON'

        write(21, *) '#ZS SBL: Mom.: Roughn.Length= F(u*) Chamberlain (1983),  Sea '

        write(21, *) '#ZM SBL: M/H   Roughn.Length: Box Moving Average (in Time)   '

        write(21, *) '#TI Turbul. Heat Surface Flux: Implicit numerical Scheme     '
        write(21, *) '#QE Turbul. H2O  Surface Flux: Explicit numerical Scheme     '
        write(21, *) '#FI Turbul. Mom. Surface Flux: Implicit numerical Scheme     '

        write(21, *) '#HY Explicit Cloud MICROPHYSICS              may be turned ON'
        write(21, *) '#hy Explicit Cloud MICROPHYSICS: NO Vectorisation Optmization'

        write(21, *) '#HV Explicit Cloud MICROPHYSICS: Air Loading by Hydrometeors '

        write(21, *) '#HW Explicit Cloud MICROPHYSICS: OUTPUT of qr,qs, qw,qi on NC'

        write(21, *) '#EE PHYSICS: radCEP: ECMWF   routine    (cfr. JJ Morcrette)  '

        write(21, *) '#SN SNOW Model                               may be turned ON'

        write(21, *) '#CZ SNOW Model: Zenithal Angle Correction  (Segal et al.1991)'

        write(21, *) '#SD SNOW Model: Antarct.,Fallen Snow Density (NP must be OFF)'

        write(21, *) '#TV Soil /Vegetation Variables                  are used     '

        write(21, *) '#LN Soil /Vegetation Model: LAI(x,y,t) prescribed(MARglf.DAT)'

        write(21, *) '#IP SISVAT: Sea-Ice Fraction prescribed from SMMR and SSM/I  '
        write(21, *) '#SI SISVAT: Sea-Ice Fraction calculated from prescribed SST  '

        write(21, *) '#sa SISVAT: must be pre-processed, except for stand-alone run'

        write(21, *) '#IB OUTPUT: Ice-Sheet Surface Mass Balance  (on MARphy File )'
        write(21, *) '#ID OUTPUT: Main Dependant Variables        (on NetCDF File )'
        write(21, *) '#UL OUTPUT: Time Dimension is UNLIMITED     (on NetCDF File )'

        write(21, *) '#vL PORTABILITY: Vectorization enhanced                      '
        write(21, *) '#vN PORTABILITY: Vectorization enhanced: Leap Frog Counter   '
        write(21, *) '#vK PORTABILITY: Vectorization enhanced: TKE                 '
        write(21, *) '#vH PORTABILITY: Vectorization enhanced: Hydrological Cycle  '

        write(21, *) '#vS PORTABILITY: Vectorization enhanced: Snow     Model      '
        write(21, *) '#vV PORTABILITY: Vectorization enhanced: SVAT                '
        write(21, *) '#vZ PORTABILITY: Vectorization enhanced: Av.Roughness Length '
        write(21, *) '#HP PORTABILITY: Enables use of own    library on Linux Syst.'
        write(21, *) '#NV PORTABILITY: Vectorization  is     turned  OFF           '

        write(21, 602) &
            reaVAR, swich(-zext(reaVAR)), reaLBC, swich(-zext(reaLBC)), &
            safVAR, swich(-zext(safVAR)), hamfil, swich(-zext(hamfil))
602     format(//, ' OPTIONS', /, ' +++++++', /, &
                /, '  reaVAR=', l2, 4x, ' => Input: Prev.Dyn.Sim.(MAR/GCM) ', a3, &
                /, '  reaLBC=', l2, 4x, ' => LBC:   Prev.Dyn.Sim.(MAR/GCM) ', a3, &
                /, '  safVAR=', l2, 4x, ' => Saving    on Files MARxxx.DAT ', a3, &
                /, '  hamfil=', l2, 4x, ' => Diabatic Initialisation       ', a3)

        rhcrit = 0.0
        tstart = 0.0
        rhcrit = rhcrHY
        tstart = tim_HY
        write(21, 604) &
            conmas, swich(-zext(conmas)), potvor, swich(-zext(potvor)), &
            brocam, swich(-zext(brocam)), turhor, swich(-zext(turhor)), &
            convec, swich(-zext(convec)), &
            micphy, swich(-zext(micphy)), 1.d+2 * rhcrit, tstart, &
            fracld, swich(-zext(fracld)), &
            chimod, swich(-zext(chimod)), &
            physic, swich(-zext(physic)), &
            snomod, swich(-zext(snomod)), polmod, swich(-zext(polmod)), fxlead, &
            vegmod, swich(-zext(vegmod)), qsolSL, swich(-zext(qsolSL)), &
            rxbase, rxfact
604     format( &
            '  conmas=', l2, 4x, ' => Mass  Conservation Constraint ', a3, &
            /, '  potvor=', l2, 4x, ' => PV    Conservation Constraint ', a3, &
            /, '  brocam=', l2, 4x, ' => Brown and Campana Time Scheme ', a3, &
            /, '  turhor=', l2, 4x, ' => Horizontal Diffusion          ', a3, &
            /, '  convec=', l2, 4x, ' => Mass Flux convective Scheme   ', a3, &
            /, '  micphy=', l2, 4x, ' => Cloud Microphysics            ', a3, &
            /, '  rhcrHY=', f6.0, ' %  Critical Relative Humidity Value  ', &
            /, '  tim_HY=', f6.0, '    Cloud Microphysics Starting Time  ', &
            /, '  fracld=', l2, 4x, ' => Fractional Cloudiness Scheme  ', a3, &
            /, '  chimod=', l2, 4x, ' => Chemical Atmospheric  Model   ', a3, &
            /, '  physic=', l2, 4x, ' => Atmosphere / Surface  Physics ', a3, &
            /, '  snomod=', l2, 4x, ' => Interactive Snow      Model   ', a3, &
            /, '  polmod=', l2, 4x, ' => Interactive Polynya   Model   ', a3, &
            /, '  fxlead=', f5.2, '     Initial Minimal Lead   Fraction    ', &
            /, '  vegmod=', l2, 4x, ' => Interactive SVAT      Model   ', a3, &
            /, '  qsolSL=', l2, 4x, ' => Soil Humidity         Model   ', a3, &
            /, '  rxbase=', f6.3, '    Nudging Coeff.(Anthes et al. 1989)', &
            /, '  rxfact=', f6.1, '    Lateral Sponge Coefficient   (A89)')
        write(21, 605) dx, mx, dy, my, &
            dt, dtfast, ntFast, &
            center, nordps, staggr, &
            dtRadi, jtRadi, ntRadi, &
            dtPhys, jtPhys, ntPhys, &
            dtDiff, jtDiff, ntDiff, &
            FIslot, FIkhmn, TUkhff, TUkhmx, FIslou, FIslop
605     format(//, ' MAR DISCRETISATION', /, ' ++++++++++++++++++', &
                //, '  dx         =', f8.1, ' m   /  Nb Points : ', i12, &
                /, '  dy         =', f8.1, ' m   /  Nb Points : ', i12, &
                /, '  dt         =', f8.1, ' sec', &
                /, '  dt Lamb    =', f8.1, ' sec', &
                /, '  nt Lamb    =', i6, &
                /, '  p* Discret.=', l6, 5x, '  /  p* Precis.= ', i12, &
                /, '  Vert.Stagg.=', l6, &
                //, '  dt Sol./IR =', f8.1, ' sec => jt Sol./IR= ', i12, &
                /, '                              nt Sol./IR= ', i12, &
                //, '  dt Surface =', f8.1, ' sec => jt Surface= ', i12, &
                /, '                              nt Surface= ', i12, &
                /, ' CAUTION: := dt', &
                //, '  dt Turbul. =', f8.1, ' sec => jt Turbul.= ', i12, &
                /, '                           /  nt Turbul.= ', i12, &
                /, ' CAUTION: := dt', &
                //, '  delta T    =', f11.4, '  => Kh(delta) = ', e12.4, &
                /, '              ', 11x, '  -- fac. (Kh) = ', f12.4, &
                /, '  Absorbing Layer          -> Kh max    = ', e12.4, &
                /, '  delta u    =', f11.4, &
                /, '  delta p    =', f11.4)
    endif
    ! +
    ! +--WARNINGS
    ! +  ========
    ! +
    ! +--Time Step
    ! +  ---------
    ! +
    !     if (abs(dt-dtdom) > epsi) write(6,2) dt,dtdom
    !2    format(/,' ***********************************',
    !    .          '********************************',
    !    .       /,' * CAUTION: dt(MARctr.dat)=',f8.2,'s',
    !    .          '  /=  dt(MARdom.dat)=',f8.2,'s *',
    !    .       /,' ***********************************',
    !    .          '********************************',/,1x)
    ! +
    ! +
    ! +--Topography
    ! +  ----------
    ! +
    lo_CAU = 0
    if(n7mxLB > 1) then
        do j = 1, my
            do i = 1, n7mxLB - 1
                if(abs(sh(i, j) - sh(ip1(i), j)) > epsi) lo_CAU = 1
            enddo
        enddo
    endif
    ! +
    if(n6mxLB > 0) then
        do j = 1, my
            do i = mx - n6mxLB + 1, mx
                if(abs(sh(i, j) - sh(im1(i), j)) > epsi) lo_CAU = 1
            enddo
        enddo
    endif
    ! +
    if(n7myLB > 1) then
        do j = 1, n7myLB - 1
            do i = 1, mx
                if(abs(sh(i, j) - sh(i, jp1(j))) > epsi) lo_CAU = 1
            enddo
        enddo
    endif
    ! +
    if(n6myLB > 0) then
        do i = 1, mx
            do j = my - n6myLB + 1, my
                if(abs(sh(i, j) - sh(i, jm1(j))) > epsi) lo_CAU = 1
            enddo
        enddo
    endif
    ! +
    if(lo_CAU == 1) then
        write(6, 1)
1       format(' ******************************************************************', &
               /, ' * CAUTION: Lateral Sponge too large OR Lateral Plateau too small *', &
               /, ' ******************************************************************', /, 1x)
    endif

    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! +++ INITIALISATION INCLUDING A SAVED STATE OF THE VARIABLES ++++++++++++++
    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    if(reaVAR) then
        ! +--Timing
        ! +  ======
        iterun = 0
        ! +--Dynamics
        ! +  ========
        open(unit=11, status='old', form='unformatted', file='MARdyn.DAT')
        rewind 11
        ! In the coupled MAR/ice sheet model simulation, itexpe must be an integer*8 in MARCTR.inc
        ! If you started your simulation with an interger*4, you need only 1 time to use
        ! the "itexpe2" line to read an integer*4 but to save an integer*8 for the next simulation.
        ! Afterwards, you have to use the "itexpe" line to read/write an interger*8
        ! ------------------------------------------------------------------------------------------ !
        ! if itexpe is integer*8 but file in integer*4
        ! read(11) itexpe2,jdh_LB ; itexpe=itexpe2
        ! if itexpe is integer*4 / *8
        read(11) itexpe, jdh_LB
        ! ------------------------------------------------------------------------------------------ !
        ! +...    Time    Parameters
        read(11) iyrDYN, mmaDYN, jdaDYN, jhuDYN
        ! +--Modified Time Step (BEGIN)
        ! +  ~~~~~~~~~~~~~~~~~~~~~~~~~~
        YYtmp = -1
        MMtmp = -1
        DDtmp = -1
        dt_old = -1
        dt_new = -1
        open(unit=51, status='old', file='MARtime.ctr', err=51)
        read(51, *, err=51) YYtmp, MMtmp, DDtmp, dt_old, dt_new
51      continue
        close(51)
        if(YYtmp == iyrDYN .and. MMtmp == mmaDYN .and. &
           DDtmp == jdaDYN .and. dt_old > 0 .and. dt_new > 0) then
            write(6, *) ' '
            write(6, *) 'WARNING--WARNING--WARING--WARING--WARNING'
            write(6, *) 'itexpe modified by MARtime.ctr'
            write(6, *) 'dt_old =', dt_old
            write(6, *) 'dt_new =', dt_new
            write(6, *) 'WARNING--WARNING--WARING--WARING--WARNING'
            write(6, *) ' '
            itexpe = (itexpe * dt_old) / dt_new
        endif
        ! +--Modified Time Step   (end)
        ! +  ~~~~~~~~~~~~~~~~~~~~~~~~~~
        ! Spatial Parameters
        read(11) imezdy, jmezdy
        read(11) aladyn, alodyn
        ! Discretisation
        read(11) sigma, ptopDY, dx, dy
        ! Dynamics
        read(11) uairDY
        read(11) vairDY
        read(11) pktaDY
        read(11) pstDY
        read(11) qvDY
        read(11) sh

        read(11) pstDY1
        ! Lateral Boundary Conditions
        read(11) iyr_LB, mma_LB, jda_LB, jhu_LB, jdh_LB
        read(11) vaxgLB, vaxdLB, vayiLB, vaysLB
        read(11) sst_LB
        ! Upper Sponge Reference State
        read(11) uairUB, vairUB, pktaUB
        if(jdh_LB <= 0) then
            ! write(6,6000) jdh_LB
            ! 6000        format(/, '##############################################', &
            !                     /, '# CAUTION: previous jdh_LB =', i6, ' set:= 1 #', &
            !                     /, '##############################################',/)
            jdh_LB = 1
        endif
        if(itexpe > 0) then
            read(11) pstDYn
            read(11) RAd_ir
            read(11) IRsoil
            read(11) virDY
            read(11) tim1LB, v1xgLB, v1xdLB, v1yiLB, v1ysLB
            read(11) tim2LB, v2xgLB, v2xdLB, v2yiLB, v2ysLB
            read(11) sst1LB, sst2LB
            read(11) ua1_UB, ua2_UB
            read(11) va1_UB, va2_UB
            read(11) pkt1UB, pkt2UB
            if(my == 1) then
                read(11) ugeoDY
                read(11) vgeoDY

            endif
        endif
        close(unit=11)

        ! +--sigma-levels Height
        ! +  -------------------
        do k = 1, mz
            zsigma(k) = -(sst_SL / 0.0065) * ((1.e0 + (sigma(k) - 1.) &
                                               * (1.e2 / ps_sig)) &
                                              **(RDryAi * 0.0065 / gravit) - 1.)
        enddo
        if(IO_gen >= 2) then
            write(21, 130)(sigma(k), k=1, mz)
            write(21, 131)(zsigma(k), k=1, mz)
        endif

        ! +--Auxiliary Grid Parameters
        ! +  -------------------------
        ! +  ******
        call grdmar
        ! +  ******

        ! +--Geographical Coordinates
        ! +  ------------------------
        ! +  ******
        call grdgeo
        ! +  ******

        ! +--Local Time of the Model Center
        ! +  ------------------------------
        ! +  ******
        call timcur
        call timgeo
        ! +  ******

        ! +--LBC Coefficients
        ! +  ----------------
        if(itexpe == 0) then
            tim1LB = ou2sGE(iyr_LB, mma_LB, jda_LB, jhu_LB, 0, 0)
            tim2LB = tim1LB
            do iv_ini = 1, 5
                do i = 1, n7mxLB
                    do k = 1, mz
                        do j = 1, my
                            v1xgLB(i, j, k, iv_ini) = vaxgLB(i, j, k, iv_ini)
                            v2xgLB(i, j, k, iv_ini) = vaxgLB(i, j, k, iv_ini)
                        enddo
                    enddo
                enddo
                do i = mx - n6mxLB, mx
                    do k = 1, mz
                        do j = 1, my
                            v1xdLB(i, j, k, iv_ini) = vaxdLB(i, j, k, iv_ini)
                            v2xdLB(i, j, k, iv_ini) = vaxdLB(i, j, k, iv_ini)
                        enddo
                    enddo
                enddo
                do j = 1, n7myLB
                    do k = 1, mz
                        do i = 1, mx
                            v1yiLB(i, j, k, iv_ini) = vayiLB(i, j, k, iv_ini)
                            v2yiLB(i, j, k, iv_ini) = vayiLB(i, j, k, iv_ini)
                        enddo
                    enddo
                enddo
                do j = my - n6myLB, my
                    do k = 1, mz
                        do i = 1, mx
                            v1ysLB(i, j, k, iv_ini) = vaysLB(i, j, k, iv_ini)
                            v2ysLB(i, j, k, iv_ini) = vaysLB(i, j, k, iv_ini)
                        enddo
                    enddo
                enddo
            enddo
        endif

        ! +  **********
        call lbcnud_ini
        ! +  **********

        ! +  **********
        call lbcnud_par
        ! +  **********

        ! +--Soil Model
        ! +  ==========
        open(unit=11, status='old', form='unformatted', file='MARsol.DAT')
        rewind 11
        read(11) itever
        read(11) iyrSOL, mmaSOL, jdaSOL, jhuSOL
        if(itever /= itexpe .or. &
           iyrSOL /= iyrDYN .or. &
           mmaSOL /= mmaDYN .or. &
           jdaSOL /= jdaDYN .or. &
           jhuSOL /= jhuDYN) then
            write(6, 817)
817         format(' ++WARNING++ MARsol improperly specified ')
        endif
        read(11) nSLsrf
        read(11) SLsrfl
        read(11) TairSL
        read(11) tsrfSL
        read(11) alb0SL, eps0SL
        read(11) SaltSL
        read(11) ro_SL0
        read(11) ro_SL
        read(11) d1_SL
        read(11) t2_SL
        read(11) w2_SL, wg_SL
        read(11) roseSL
        read(11) qvapSL
        read(11) hsnoSL
        read(11) hmelSL
        read(11) SLuusl, SL_z0
        read(11) SLutsl, SL_r0
        if(itexpe > 0) then
            read(11) pktaSL
            read(11) sicsIB
            read(11) sic1sI, sic2sI
            read(11) albeSL
            read(11) SLuus, SLuts
            read(11) SLuqs, SLuqsl
            read(11) duusSL
            read(11) dutsSL
            read(11) cdmSL, cdhSL
            read(11) V_0aSL
            read(11) dT0aSL

            read(11) SLlmo, SLlmol

        endif
        close(unit=11)

        if(itexpe == 0) then
            open(unit=11, status='old', form='unformatted', file='MARsic.DAT')
            rewind 11
            read(11) iyr_sI, mma_sI, jda_sI, jhu_sI, jdh_sI
            read(11) sicsIB
            close(unit=11)
        endif
        ! +--Update of Soil Parameters
        ! +  -------------------------
        Tfr_LB = tfrwat

        do j = 1, my
            do i = 1, mx
                if(isolSL(i, j) <= 2) then
                    ! +---1. Open Water
                    ! +   ~~~~~~~~~~~~~
                    if(sst_LB(i, j) >= Tfr_LB) then
                        isolSL(i, j) = 1
                        d1_SL(i, j) = 2.09e+8
                        albeSL(i, j) = 0.10
                        eps0SL(i, j) = 0.97
                        SL_z0(i, j, 1) = zs_SL
                        SL_r0(i, j, 1) = 0.1 * zs_SL
                        ch0SL(i, j) = 0.00132
                        rsurSL(i, j) = 0.0
                    else
                        ! +---2. Sea Ice
                        ! +   ~~~~~~~~~~
                        ! (Kondo and Yamazaki, 1990, JAM 29, p.376)
                        isolSL(i, j) = 2
                        d1_SL(i, j) = 1.05e+5
                        albeSL(i, j) = 0.70
                        eps0SL(i, j) = 0.97
                        SL_z0(i, j, 1) = zn_SL
                        SL_r0(i, j, 1) = 0.1 * zn_SL
                        ch0SL(i, j) = 0.0021
                        rsurSL(i, j) = 0.0
                    endif
                endif
            enddo
        enddo

        ! +--SVAT Model
        ! +  ==========
        if(vegmod) then
            ! +       ***********
            call svasav('read')
            ! +       ***********
        endif

        if(itexpe > 0) then

            ! +--Mass Flux convective Scheme
            ! +  ===========================
            if(convec) then
                open(unit=11, status='old', form='unformatted', file='MARcva.DAT')
                rewind 11
                read(11) itever
                ! Time    Parameters
                read(11) iyrCVA, mmaCVA, jdaCVA, jhuCVA
                if(itever /= itexpe .or. &
                   iyrCVA /= iyrDYN .or. &
                   mmaCVA /= mmaDYN .or. &
                   jdaCVA /= jdaDYN .or. &
                   jhuCVA /= jhuDYN) then
                    write(6, 811)
811                 format(' ++WARNING++ MARcva improperly specified ')
                endif
                read(11) adj_CA
                read(11) int_CA
                read(11) dpktCA
                read(11) dqv_CA
                read(11) dqw_CA
                read(11) dqi_CA
                read(11) drr_CA
                read(11) dss_CA
                read(11) dsn_CA
                read(11) rainCA
                read(11) snowCA
                read(11) tau_CA
                read(11) Kstep1
                read(11) K_CbT1
                read(11) K_CbB1
                read(11) P_CH_0
                read(11) PdCH_1
                read(11) PdTa_1
                read(11) PdQa_1
                read(11) PdQw_1
                read(11) PdQi_1
                read(11) Pdrr_1
                read(11) Pdss_1
                read(11) PuMF_1
                read(11) PdMF_1
                read(11) Pfrr_1
                read(11) Pfss_1
                read(11) Pcape1
                close(unit=11)

            endif

            ! +--Microphysics
            ! +  ============
            if(micphy) then
                open(unit=11, status='old', form='unformatted', file='MARcld.DAT')
                rewind 11
                read(11) itever
                read(11) iyrHYD, mmaHYD, jdaHYD, jhuHYD
                if(itever /= itexpe .or. &
                   iyrHYD /= iyrDYN .or. &
                   mmaHYD /= mmaDYN .or. &
                   jdaHYD /= jdaDYN .or. &
                   jhuHYD /= jhuDYN) write(6, 812)
812             format(' ++WARNING++ MARcld improperly specified ')
                ! +
                read(11) turnHY
                read(11) ccniHY
                read(11) qiHY
                read(11) qsHY
                ! +HG read(11) qgHY
                read(11) qwHY
                read(11) qrHY
                read(11) rainHY, rai0HY
                read(11) snowHY, sno0HY, sfa0HY
                read(11) crysHY
                read(11) rainCA

                close(unit=11)

            endif

            ! +--Turbulence
            ! +  ==========
            open(unit=11, status='old', form='unformatted', file='MARtur.DAT')
            rewind 11
            read(11) itever
            read(11) iyrTUR, mmaTUR, jdaTUR, jhuTUR
            if(itever /= itexpe .or. &
               iyrTUR /= iyrDYN .or. &
               mmaTUR /= mmaDYN .or. &
               jdaTUR /= jdaDYN .or. &
               jhuTUR /= jhuDYN) then
                write(6, 816)
816             format(' ++WARNING++ MARtur improperly specified ')
            endif
            ! TURBULENT KINETIC ENERGY (TKE) and DISSIPATION (e)
            read(11) ect_TE
            read(11) eps_TE
            read(11) tranTE
            ! TURBULENT DifFUSION COEFFICIENT
            read(11) TUkvm
            read(11) TUkvh
            close(unit=11)
        else
            ! +--Timing
            ! +  ======
            itexpe = 0
            iterun = 0
            ! +--Atmosphere
            ! +  ==========
            ! +
            do j = 1, my
                do i = 1, mx
                    pstDYn(i, j) = pstDY(i, j)
                enddo
            enddo
            ! +  *********
            call dyngpo_mp
            ! +  *********
            ! +--Microphysics and Surface
            ! +  ========================
            ! +  ******
            call iniphy
            ! +  ******
            ! +--Water Vapor and Precipitation Loading
            ! +  -------------------------------------
            ! +  ******
            call dynloa
            ! +  ******
            ! +--Surface Albedo (set to underlaying Soil Albedo)
            ! +  --------------
            do j = 1, my
                do i = 1, mx
                    alb0SL(i, j) = max(albsSL(i, j), alb0SL(i, j))
                    albeSL(i, j) = max(albsSL(i, j), albeSL(i, j))
                enddo
            enddo
        endif
    else
        ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ! +++ INITIALISATION INCLUDING A SOUNDING ++++++++++++++++++++++++++++++++++
        ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ! cCAiso : no isotope for sounding
        ! +--Timing
        ! +  ======
        itexpe = 0
        iterun = 0
        ! +--Dynamics
        ! +  ========
        ! +--Vertical  Grid Initialisation
        ! +  -----------------------------
        ! +                   ******
        if(.not. geoNST) call grdsig(zmin_0, aavu_0, bbvu_0, ccvu_0, verti0)
        ! +                   ******
        ! +
        ! +--Auxiliary Grid Parameters
        ! +  -------------------------
        ! +  ******
        call grdmar
        ! +  ******
        ! +
        ! +--Geographical Coordinates
        ! +  ------------------------
        ! +  ******
        call grdgeo
        ! +  ******
        ! +
        ! +--Local Time of the Model Center
        ! +  ------------------------------
        ! +  ******
        call timcur
        call timgeo
        ! +  ******
        ! +
        ! +--Initialisation assuming horizontal Homogeneity
        ! +  ----------------------------------------------
        ! +  ******
        call inisnd
        ! +  ******
        ! +
        ! +  **********
        call lbcnud_ini
        ! +  **********
        ! +
        ! +  **********
        call lbcnud_par
        ! +  **********
        ! +
        ! +--Leapfrog Auxiliary Variables
        ! +  ============================
        do j = 1, my
            do i = 1, mx
                pstDYn(i, j) = pstDY(i, j)
            enddo
        enddo
        ! +
        ! +--Microphysics and Surface
        ! +  ========================
        ! +  ******
        call iniphy
        ! +  ******
        ! +
        ! +--Water Vapor and Precipitation Loading
        ! +  -------------------------------------
        ! +  ******
        call dynloa
        ! +  ******
        ! +
        ! +--Surface Albedo (set to underlaying Soil Albedo)
        ! +  --------------
        do j = 1, my
            do i = 1, mx
                alb0SL(i, j) = max(albsSL(i, j), alb0SL(i, j))
                albeSL(i, j) = max(albsSL(i, j), albeSL(i, j))
            enddo
        enddo
    endif
    ! +
    ! +
    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! +++ AUXILIARY VARIABLES INITIALISATION +++++++++++++++++++++++++++++++++++
    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! +
    ! +
    ! +--Parameters
    ! +  ==========
    ! +
    ipri = 0
    ! +... print parameter used in Model  Validation
    ! +                         on Linear Mountain Waves Simulations
    ! +
    ! +--Atmospheric variables
    ! +  =====================
    ! +
    ! +
    ! +--Leapfrog Auxiliary Variables
    ! +  ----------------------------
    ! +
    do k = 1, mz
        do j = 1, my
            do i = 1, mx
                ubefDY(i, j, k) = uairDY(i, j, k)
                vbefDY(i, j, k) = vairDY(i, j, k)
            enddo
        enddo
    enddo
    ! +
    ! +
    ! +--Surface Geopotential
    ! +  --------------------
    ! +
    do j = 1, my
        do i = 1, mx
            gplvDY(i, j, mzz) = gravit * sh(i, j)
        enddo
    enddo
    ! +
    ! +
    ! +--Exner Potential, Temperature and Level Geopotential
    ! +  ---------------------------------------------------
    ! +
    ! +  *********
    call dyngpo_mp
    ! +  *********
    ! +
    ! +--Mid-Level Geopotential
    ! +  ----------------------
    ! +
    k = 1
    do j = 1, my
        do i = 1, mx
            gpmiDY(i, j, k) = 0.5 * (3.5 * gplvDY(i, j, 1) - 0.5d0 * gplvDY(i, j, 2))
        enddo
    enddo
    ! +
    do k = kp1(1), mzz
        do j = 1, my
            do i = 1, mx
                gpmiDY(i, j, k) = 0.5 * (gplvDY(i, j, k - 1) + gplvDY(i, j, k))
            enddo
        enddo
    enddo
    ! +
    k = mzz
    do j = 1, my
        do i = 1, mx
            gpmiDY(i, j, k) = (0.5 * z__SBL + sh(i, j)) * gravit
        enddo
    enddo
    ! +--Vertical Temperature Gradient at Sponge Base
    ! +  --------------------------------------------
    ! +
    gradTz = 1.0e+3 * grvinv
    if(mzabso > 1) then
        mzabs1 = max(mzabso - 1, 1)
        do j = 1, my
            do i = 1, mx
                gradTz = min(gradTz,(tairDY(i, j, mzabs1) - tairDY(i, j, mzabso)) &
                             / (epsi + gplvDY(i, j, mzabs1) - gplvDY(i, j, mzabso)))
            enddo
        enddo
    endif
    gradTz = gradTz * gravit * 1.0d+3

    ! +
    ! +
    ! +--Specific Mass
    ! +  -------------
    ! +  ******
    call dynrho
    ! +  ******
    ! +
    ! +--Surface Variables
    ! +  =================
    ! +
    ! +--Land-Sea Mask
    ! +  -------------
    do j = 1, my
        do i = 1, mx
            if(isolSL(i, j) <= 2) then
                maskSL(i, j) = 1
            else
                maskSL(i, j) = 0
            endif
        enddo
    enddo
    ! +--OUTPUT
    ! +  ======
    if(IO_loc >= 1) then
        write(21, 606) jdaMAR, jhaMAR, itexpe, nboucl, nprint, &
            0.1 * pSND(1, 1), pstSND, sst_SL, dtagSL, &
            zs_SL, zn_SL, gradtz, mzabso
606     format(//, ' EXECUTION STATUS', /, ' ++++++++++++++++', /, &
                /, ' Preceding Execution stopped after', i5, ' day(s)', i5, ' hour(s)', &
                /, '  itexpe =', i8, 8x, '  nboucl =', i8, 8x, 'nprint =', i8, &
                /, '  p MSL  =', f8.1, ' cb', 5x, 'p* 0   =', f8.1, ' cb', &
                /, '  SST    =', f8.1, ' K ', 5x, 'T0-Tg  =', f8.1, ' K ', &
                /, '  zs     =', f8.5, ' m ', 5x, 'zn     =', f8.5, ' m ', &
                /, '  dT/dz >=', f8.2, ' K/km / mzabso =', i8, ' Sponge Base')
        if(gradtz < -4.0) write(6, 607) gradtz, mzabso
607     format(/, ' WARNING: dT/dz Min =', f8.2, ' K/km at Sponge Base (k=mzabso=', i2, ')')
    endif
    return
endsubroutine inigen

integer function zext(logvar)
    logical, intent(in) :: logvar
    if(logvar) then
        zext = -1
    else
        zext = 0
    endif
    return
endfunction zext
