# -*- coding: utf-8 -*-
"""
Created on Wed Oct 18 11:15:29 2023

@author: Thomas
"""

#
# ----------------------------------------------------------------------------------------------------------------------
#
#     Call all the necessary routine to interpolate the MAR file to CAR or the opposite
#
# ----------------------------------------------------------------------------------------------------------------------


# ----------------------------------------------------------------------------------------------------------------------
#
#          Imports and global variables
#      \**********************************/
#

import time

from MAR2CAR_clim import main_climatology

from MAR2CAR_landuse import main_landuse

#from CAR2MAR_sowing import main_sowing   TODO

from CAR2MAR_fire import main_fire

from CAR2MAR_manage import main_manag

from CAR2MAR_co2_tprev import main_co2, main_tprev

# ----------------------------------------------------------------------------------------------------------------------
#
#           Functions
#       \***************/
#
#
#   Here you can define usefull functions to be used in the main
#
"""##############################################################################################################"""
def ti():
    return time.time()
"""##############################################################################################################"""

#           Main
#       \**********/
#
#
#   Here you can define the instructions that are called when you execute this file
#
if __name__ == '__main__':
    t0=ti()
    
    path_to_MAR_ICE = "E:/MAR_data_raw_BE/MERRA/"
    
    path_to_sowing = "E:/MAR_data_raw_BE/MERRA/"
    path_to_fire = "E:/Car_files/data.ascii" #data.ascii input file
    path_to_manage = "./man/" #manageYYYY.dat file output
    
    do_sowing = 0
    do_fire = 1
    do_manage = 1
    
    
    # manage_type = [0,1,1,100,100] #no cut
    manage_type = [2,1,365,0,0] #full cut
    # manage_type = [1,1,150,50,50] #user defined
    ys = 2009 #starting year -1
    ye = 2024 #end year
    
    # print("Creating the climatology files")
    # main_climatology(path_to_MAR_ICE)

    print("Creating the Landuse files")
    main_landuse(path_to_MAR_ICE)
    
    print("Creating the C02 files")
    main_co2(ys,ye)
    
    print("Creating the Temprev")
    main_tprev(ys)
    
    # print("Creating the sowing files")  TODO
    # if do_sowing : main_sowing(path_to_sowing, path_to_MAR_ICE)
    
    print("Creating the fire files")
    if do_fire : main_fire(path_to_fire, path_to_MAR_ICE)
    
    print("Creating the manage files")
    if do_manage : main_manag(path_to_manage, path_to_MAR_ICE, manage_type,ys,ye)
    
    









    print("All scripts have completed.")
  
    t1=ti()
    print('Programme compiled in ',t1-t0, 'sec')